      SUBROUTINE CALAWP
      INCLUDE 'cgdims.cmn'
      INCLUDE 'comany.cmn'
      INCLUDE 'comawp.cmn'
      REAL DIST, ATRG, ATRP, YINP, aleft, wplt, arite, wprt, ylft, yrht, 
     &     yy, amin, wpmn, yyy, yu, holdw, x1, x2, xu, y1, y2
      INTEGER lidy, midy, k, ierr, kk, limit, k0, l, m
      SAVE lidy, midy, wpmn, amin
      DATA lidy/1/, midy/1/, wpmn/0.0/, amin/0.0/
      DIST(x1,y1,y2) = SQRT(x1**2+(y2-y1)**2)
      ATRG(x1,y1,y2) = ABS((y1-y2)*x1)
      ATRP(x1,xu,y1,y2) = ((xu-y1)+(xu-y2))*x1
      YINP(x1,y1,xu,x2,y2) = (x2-x1)*(xu-y1)/(y2-y1) + x1
      Width = 0.0
      Wltc = 0.0
      Wrtc = 0.0
      aleft = 0.0
      wplt = 0.0
      Altc = 0.0
      Wpltc = 0.0
      arite = 0.0
      wprt = 0.0
      Artc = 0.0
      Wprtc = 0.0
      Ymid = 0.0
      ylft = 0.0
      yrht = 0.0
      IF (Jflag.NE.1) THEN
C CALCULATE AREA, WETTED PERIMETER, AVERAGE DEPTH AT MINIMUM STAGE
        S = Zmin
        DO 40 k = 1, Many
          IF (H(k).EQ.0.0) THEN
            Yzmax = Y(k)
            k0 = k
            DO 30 l = k0, Many
              IF (H(l).EQ.S) THEN
                Ym = Y(l)
              ELSEIF (H(l).GT.S) THEN
                Ym = YINP(Y(l-1),H(l-1),S,Y(l),H(l))
              ELSE
                GOTO 30
              ENDIF
              midy = l - 1
   10         IF (H(k0).LT.S) THEN
                k0 = k0 - 1
                IF (k0.NE.0) GOTO 10
                ierr = 7
                GOTO 80
              ELSEIF (H(k0).EQ.S) THEN
                Yl = Y(k0)
              ELSE
                Yl = YINP(Y(k0),H(k0),S,Y(k0+1),H(k0+1))
              ENDIF
              lidy = k0 + 1
              yy = Y(lidy) - Yl
              amin = 0.0
              wpmn = 0.0
              yyy = Ym - Y(midy)
              amin = ATRG(yy,S,H(lidy)) + ATRG(yyy,S,H(midy))
              wpmn = DIST(yy,S,H(lidy)) + DIST(yyy,S,H(midy))
              limit = midy - 1
              DO 20 m = lidy, limit
                yy = Y(m+1) - Y(m)
                amin = amin + ATRP(yy,S,H(m),H(m+1))
                wpmn = wpmn + DIST(yy,H(m),H(m+1))
   20         CONTINUE
              Y(lidy) = Yl
              H(lidy) = Zmin
              Y(midy) = Ym
              H(midy) = Zmin
              amin = amin*0.5
              Area = amin
              Wetp = wpmn
              Ymid = (Ym-Yl)*0.5 + Yl
              GOTO 70
   30       CONTINUE
            ierr = 7
            GOTO 80
          ENDIF
   40   CONTINUE
        ierr = 6
        GOTO 80
      ELSE
C CALCULATE WIDTH, AREA, AND WETTED PERIMETER AT LEW
        limit = lidy - 1
        DO 50 k = 1, limit
          kk = k + 1
          IF (k.EQ.limit .AND. S.LT.H(k)) THEN
            yu = YINP(Y(k),H(k),S,Y(kk),H(kk))
            yy = Yl - yu
            wplt = wplt + DIST(yy,S,Zmin)
            Width = Width + yy
            aleft = aleft + ATRG(yy,S,Zmin)
          ENDIF
          IF (H(k).LT.S) THEN
            IF (k.EQ.1) THEN
              ierr = 8
              GOTO 80
            ENDIF
            IF (H(k-1).GT.S) THEN
              yu = YINP(Y(k-1),H(k-1),S,Y(k),H(k))
              yy = Y(k) - yu
              wplt = wplt + DIST(yy,S,H(k))
              Width = Width + yy
              aleft = aleft + ATRG(yy,S,H(k))
              IF (ylft.EQ.0.0) ylft = yu
            ENDIF
            IF (H(kk).LT.S) THEN
              yy = Y(kk) - Y(k)
              wplt = wplt + DIST(yy,H(k),H(kk))
              Width = Width + yy
              aleft = aleft + ATRP(yy,S,H(k),H(kk))
            ELSEIF (H(kk).EQ.S) THEN
              yy = Y(kk) - Y(k)
              wplt = wplt + DIST(yy,S,H(kk))
              Width = Width + yy
              aleft = aleft + ATRG(yy,S,H(kk))
              IF (ylft.EQ.0.0) ylft = Y(k)
              IF (H(kk).EQ.S) THEN
                Altc = Altc + aleft
                aleft = 0.0
                Wltc = Wltc + Width
                Width = 0.0
                Wpltc = Wpltc + wplt
                wplt = 0.0
              ENDIF
            ELSE
              yu = YINP(Y(k),H(k),S,Y(kk),H(kk))
              yy = yu - Y(k)
              wplt = wplt + DIST(yy,H(k),S)
              Width = Width + yy
              aleft = aleft + ATRG(yy,S,H(k))
              Altc = Altc + aleft
              aleft = 0.0
              Wltc = Wltc + Width
              Width = 0.0
              Wpltc = Wpltc + wplt
              wplt = 0.0
            ENDIF
          ELSEIF (H(k).EQ.S .AND. H(kk).LT.S) THEN
            yy = Y(kk) - Y(k)
            wplt = wplt + DIST(yy,S,H(kk))
            Width = Width + yy
            aleft = aleft + ATRG(yy,S,H(kk))
            IF (ylft.EQ.0.0) ylft = Y(k)
            IF (H(kk).EQ.S) THEN
              Altc = Altc + aleft
              aleft = 0.0
              Wltc = Wltc + Width
              Width = 0.0
              Wpltc = Wpltc + wplt
              wplt = 0.0
            ENDIF
          ENDIF
   50   CONTINUE
C CALCULATE WIDTH, AREA, AND WETTED PERIMETER AT REW
        holdw = Width
        Width = 0.0
        k = Many
   60   kk = k - 1
        IF (H(k).LT.S) THEN
          IF (k+1.GT.Many) THEN
            ierr = 9
            GOTO 80
          ENDIF
          IF (H(k+1).GT.S) THEN
            yu = YINP(Y(k),H(k),S,Y(k+1),H(k+1))
            IF (yrht.EQ.0.0) yrht = yu
            yy = yu - Y(k)
            wprt = wprt + DIST(yy,H(k),S)
            Width = Width + yy
            arite = arite + ATRG(yy,S,H(k))
          ENDIF
          IF (H(kk).LT.S) THEN
            yy = Y(k) - Y(kk)
            wprt = wprt + DIST(yy,H(kk),H(k))
            Width = Width + yy
            arite = arite + ATRP(yy,S,H(kk),H(k))
          ELSEIF (H(kk).EQ.S) THEN
            yy = Y(k) - Y(kk)
            IF (yrht.EQ.0.0) yrht = Y(k)
            wprt = wprt + DIST(yy,H(kk),S)
            Width = Width + yy
            arite = arite + ATRG(yy,S,H(kk))
            IF (H(kk).EQ.S) THEN
              Artc = Artc + arite
              arite = 0.0
              Wrtc = Wrtc + Width
              Width = 0.0
              Wprtc = Wprtc + wprt
              wprt = 0.0
            ENDIF
          ELSE
            yu = YINP(Y(kk),H(kk),S,Y(k),H(k))
            yy = Y(k) - yu
            wprt = wprt + DIST(yy,S,H(k))
            Width = Width + yy
            arite = arite + ATRG(yy,S,H(k))
            Artc = Artc + arite
            arite = 0.0
            Wrtc = Wrtc + Width
            Width = 0.0
            Wprtc = Wprtc + wprt
            wprt = 0.0
          ENDIF
        ELSEIF (H(k).EQ.S .AND. H(kk).LT.S) THEN
          yy = Y(k) - Y(kk)
          IF (yrht.EQ.0.0) yrht = Y(k)
          wprt = wprt + DIST(yy,H(kk),S)
          Width = Width + yy
          arite = arite + ATRG(yy,S,H(kk))
          IF (H(kk).EQ.S) THEN
            Artc = Artc + arite
            arite = 0.0
            Wrtc = Wrtc + Width
            Width = 0.0
            Wprtc = Wprtc + wprt
            wprt = 0.0
          ENDIF
        ENDIF
        k = kk
        IF (k.NE.midy) GOTO 60
        IF (S.LT.H(k+1)) THEN
          yu = YINP(Y(k),H(k),S,Y(k+1),H(k+1))
          yy = yu - Ym
          wprt = wprt + DIST(yy,Zmin,S)
          Width = Width + yy
          arite = arite + ATRG(yy,S,Zmin)
        ENDIF
        yy = (S-Zmin)*(Ym-Yl)
        Altc = Altc*0.5
        Artc = Artc*0.5
        Area = amin + (aleft+arite)*0.5 + yy
        Wetp = wpmn + wplt + wprt
        Width = Width + holdw
        Ymid = (yrht-ylft)*0.5 + ylft
      ENDIF
   70 RETURN
   80 CALL ERRPRT(ierr)
      STOP
      END
