      SUBROUTINE PERPLT(*,*)
C
      REAL XLOC, XINP, tmp, zscl, wplt, wprt, duff, alpha, theta, xp, 
     &     xpos, ypos, xposn, yposn
      INTEGER i, j, inum, ierr, nrch, loop
      INCLUDE 'cgdims.cmn'
      INCLUDE 'comdat.cmn'
      INCLUDE 'comany.cmn'
      INCLUDE 'cgunit.cmn'
      INCLUDE 'comhid.cmn'
      INCLUDE 'comtdp.cmn'
      INTEGER nplts, ibnd(MAXS7), lrch(MAXS7), indx, is
      REAL wlew, wrew, xlen, sina, cosa, sint, cost, siz3, siz4, siz3hf, 
     &     xscale, yscale, zscale, wetl(MAXPTS), thal(MAXPTS), ptwd, 
     &     ythal, ytrans, ztrans, hthal, yorgin, x1, y1, yu, x2, y2
      CHARACTER cangle*34, cdepth*45, cwidth*41, clngth*30, cdatum*46
      SAVE wlew, wrew, xlen, sina, cosa, sint, cost, siz3, siz4, siz3hf, 
     &  xscale, yscale, zscale, wetl, thal, ptwd, ythal, ytrans, ztrans, 
     &  hthal, yorgin, x1, y1, yu, x2, y2, nplts, ibnd, lrch, indx
      DATA wlew/0.0/, wrew/0.0/, xlen/30.0/, sina/0.0/, cosa/0.0/, 
     &     sint/0.0/, cost/0.0/, siz3/0.5/, siz4/0.6/, siz3hf/0.25/, 
     &     nplts/1/, ibnd/MAXS7*0/, lrch/MAXS7*0/, xscale/1.0/, 
     &     yscale/1.0/, indx/1/, wetl/MAXPTS*0./, thal/MAXPTS*0./, 
     &     ptwd/0./, yorgin/0./, ythal/0.0/, hthal/0.0/, ytrans/0.0/, 
     &     ztrans/0.0/, zscale/1.0/
      XINP(x1,y1,yu,x2,y2) = (x2-x1)*(yu-y1)/(y2-y1) + x1
      IF (Iflag.EQ.1) THEN
        IF (Parm.EQ.1) THEN
          Zlen = 6.5
          Dlen = 15.0
          IF (Siz3d.NE.0.0) THEN
            siz3 = Siz3d
            siz3hf = Siz3d*0.5
            siz4 = Siz3d*1.2
          ENDIF
          indx = 1
          lrch(1) = 0
          IF (Inxs.GT.MAXS68) THEN
            ierr = 33
            GOTO 260
          ENDIF
          nrch = 4
          IF (Nstage.NE.0) nrch = Nstage - 1
          nplts = 1
          ibnd(1) = MIN0(Inxs,nrch+1)
          IF (Inxs.GT.nrch+1) THEN
            nplts = (Inxs-nrch-1)/nrch + 1
            IF (nrch*nplts+1.LT.Inxs) nplts = nplts + 1
            DO 10 i = 2, nplts - 1
              ibnd(i) = ibnd(i-1) + nrch
   10       CONTINUE
            ibnd(nplts) = Inxs
            IF (Inxs-ibnd(nplts-1).LT.nrch-1) ibnd(nplts-1)
     &          = Inxs - (nrch+2+Inxs-ibnd(nplts-1))/2 + 1
          ENDIF
        ENDIF
        IF (Parm.GT.ibnd(indx)) THEN
          indx = indx + 1
          lrch(indx) = IFIX(Diff)
        ELSE
          lrch(indx) = lrch(indx) + IFIX(Diff)
        ENDIF
C DETERMINE THE LOCATION OF THALWEG AT CROSS SECTIONS FOR 3D PLOT
        DO 20 i = 1, Many
          IF (H(i).EQ.0.0) THEN
            Loct = i
            GOTO 30
          ENDIF
   20   CONTINUE
   30   thal(Parm) = Y(Loct)
        duff = Zzmin - Slow
        DO 40 i = 1, Many
          is = i
          IF ((H(i)+duff).LT.Amaxp) GOTO 50
          IF ((H(i)+duff).EQ.Amaxp) THEN
            wplt = Y(is)
            GOTO 60
          ENDIF
   40   CONTINUE
   50   IF (is.EQ.1) THEN
          wplt = Y(is)
        ELSE
          wplt = XINP(Y(is-1),H(is-1)+duff,Amaxp,Y(is),H(is)+duff)
        ENDIF
   60   IF (thal(Parm)-wplt.GT.wlew) wlew = thal(Parm) - wplt
        j = Many
        DO 70 i = 1, Many
          IF (H(i)+duff.LE.Amaxp) j = i
   70   CONTINUE
        IF (H(j)+duff.EQ.Amaxp .OR. j.EQ.Many) THEN
          wprt = Y(j)
        ELSE
          wprt = XINP(Y(j),H(j)+duff,Amaxp,Y(j+1),H(j+1)+duff)
        ENDIF
        IF (wprt-thal(Parm).GT.wrew) wrew = wprt - thal(Parm)
        thal(Parm) = thal(Parm) - wplt
        wetl(Parm) = wplt
        RETURN 1
      ELSEIF (Iflag.EQ.2) THEN
        Iflag = 3
        Iarow(1) = 1
        Iarow(2) = 1
        REWIND Idev
        theta = 3.1415927*Thedeg/180.
        sint = SIN(theta)
        cost = COS(theta)
        alpha = 3.1415927*(90.-Thedeg+20.)/180.
        sina = SIN(alpha)*0.30
        cosa = COS(alpha)*0.30
        zscale = Amaxp/Zlen
        yscale = (wrew+wlew)/(Dlen-1.0)
        ptwd = wlew + wrew + yscale
        nrch = lrch(1)
        DO 80 i = 2, nplts
          IF (lrch(i).GT.nrch) nrch = lrch(i)
   80   CONTINUE
        xscale = nrch/xlen
C
        IF (.NOT.Pflag) CALL PLOTS(Pltunt,1,0)
C
        CALL PLOT(2.0,1.0,-3)
        CALL FACTOR(0.17)
        CALL NEWPEN(Lblclr)
        IF (Daref.EQ.0.0) THEN
          xp = (Dlen-22.0*siz3)*0.5
          WRITE (cdatum,'(A9,A20,17X)') 'DATUM IS ', Dtmnam
        ELSE
          tmp = XLOC(Daref,siz3)
          xp = (Dlen+(tmp-(38.0*siz3)))*0.5
          IF (Daref.LT.0.0) THEN
            WRITE (cdatum,'(A8,F7.2,A11,A20)') 'DATUM IS', ABS(Daref), 
     &             ' FT. BELOW ', Dtmnam
          ELSE
            WRITE (cdatum,'(A8,F7.2,A11,A20)') 'DATUM IS', ABS(Daref), 
     &             ' FT. ABOVE ', Dtmnam
          ENDIF
        ENDIF
        CALL SYMBOL(xp,0.0,siz3,cdatum,0.0,46)
        xpos = (Dlen-34.0*siz3)*0.5
        ypos = siz3 + siz3hf
        WRITE (cangle,'(A,I4,A)') 'VIEWING ANGLE THETA IS', IFIX(Thedeg)
     &                            , ' DEGREES'
        CALL SYMBOL(xpos,ypos,siz3,cangle,0.0,34)
        xpos = (Dlen-45.*siz3)*0.5
        ypos = ypos + ypos
        WRITE (cdepth,'(A,F7.2,A)') 'DEPTH OF DEEPEST CROSS SECTION IS', 
     &                              Amaxp, ' FEET'
        CALL SYMBOL(xpos,ypos,siz3,cdepth,0.0,45)
        xpos = (Dlen-40.*siz3)*0.5
        ypos = ypos + siz3 + siz3hf
        WRITE (cwidth,'(A,I6,A)') 'WIDTH OF CROSS SECTION PLOT IS', 
     &                            IFIX(ptwd), ' FEET'
        CALL SYMBOL(xpos,ypos,siz3,cwidth,0.0,41)
        xpos = (Dlen-29.*siz3)*0.5
        ypos = ypos + siz3 + siz3hf
        nrch = 0
        DO 90 i = 1, nplts
          nrch = nrch + lrch(i)
   90   CONTINUE
        tmp = nrch
        WRITE (clngth,'(A,I7,A)') 'LENGTH OF REACH IS', IFIX(tmp), 
     &                            ' FEET'
        CALL SYMBOL(xpos,ypos,siz3,clngth,0.,30)
        xpos = (Dlen-44.*siz4)*0.5
        ypos = ypos + siz3 + siz3hf
        xp = siz4*2.0
        DO 100 i = 1, 22
          CALL SYMBOL(xpos,ypos,siz4,Ibcd(i),0.0,1)
          xpos = xpos + xp
  100   CONTINUE
        xpos = (Dlen-44.*siz4)*0.5
        CALL PLOT(0.0,11.0*siz3,-3)
        yorgin = yorgin + 11.0*siz3
        indx = 1
        Parm = 0
        RETURN 1
      ENDIF
C
C 3D PLOT ON CALCOMP (OUTPUT OPTION 7)
C
      IF (Zzmin.LT.Slow) THEN
        ierr = 15
        GOTO 260
      ENDIF
C NORMALIZE STAGES TO DEEPEST POINT IN REACH
      duff = Zzmin - Slow
      DO 110 i = 1, Many
        IF (H(i).EQ.0.0) THEN
          Loct = i
          GOTO 120
        ENDIF
  110 CONTINUE
  120 DO 130 i = 1, Many
        H(i) = H(i) + duff
  130 CONTINUE
C NORMALIZE DISTANCES TO THALWEG OF MAXIMUM DISTANCE FROM LEW
      IF (wetl(Parm).NE.0.0) THEN
        duff = wetl(Parm)
        DO 140 i = 1, Many
          Y(i) = Y(i) - duff
  140   CONTINUE
        DO 150 i = 1, Many
          IF (Y(i).GE.0.0) GOTO 160
          Y(i) = 0.0
  150   CONTINUE
      ENDIF
  160 IF (thal(Parm).NE.wlew) THEN
        duff = wlew - thal(Parm)
        DO 170 i = 1, Many
          Y(i) = Y(i) + duff
  170   CONTINUE
        i = Many
  180   Y(i+1) = Y(i)
        H(i+1) = H(i)
        i = i - 1
        IF (i.NE.0) GOTO 180
        Y(1) = 0.0
        H(1) = Amaxp
        Many = Many + 1
        Loct = Loct + 1
      ENDIF
      Many = Many + 1
      Y(Many) = ptwd
      H(Many) = Amaxp
      DO 190 i = 1, Many
        IF (H(i).LT.Amaxp) GOTO 200
        IF (H(i).NE.Amaxp) THEN
          IF (H(i+1).LT.Amaxp) Y(i)= XINP(Y(i),H(i),Amaxp,Y(i+1),H(i+1))
          H(i) = Amaxp
        ENDIF
  190 CONTINUE
  200 i = Many
  210 IF (H(i).LT.Amaxp) THEN
        loop = 0
        IF (Parm.NE.1) THEN
          ytrans = cost*Diff/xscale
          ztrans = sint*Diff/xscale
          CALL PLOT(ytrans,ztrans,-3)
          yorgin = yorgin + ztrans
        ENDIF
        GOTO 220
      ELSEIF (H(i).NE.Amaxp) THEN
        IF (H(i-1).LT.Amaxp) Y(i) = XINP(Y(i-1),H(i-1),Amaxp,Y(i),H(i))
        H(i) = Amaxp
      ENDIF
      IF (Y(i).GT.ptwd) Y(i) = ptwd
      i = i - 1
      IF (i.NE.0) GOTO 210
      ierr = 32
      GOTO 260
  220 tmp = Nsta
      xpos = Dlen - (1.5+IFIX(ALOG10(tmp+0.05)))*siz3
      ypos = Zlen - siz3hf - siz3
      CALL NUMBER(xpos,ypos,siz3,tmp,0.0,-1)
      Y(Many+1) = 0.0
      Y(Many+2) = yscale
      H(Many+1) = 0.0
      H(Many+2) = zscale
      IF (Parm.NE.1) THEN
        IF (loop.EQ.1) GOTO 240
        IF (Zin(1)-ztrans.GT.0.0) THEN
          Iarow(2) = 1
          CALL HIDPT(ytrans,ztrans,*250)
        ENDIF
      ENDIF
      tmp = 1.0/yscale
      zscl = 1.0/zscale
      DO 230 i = 1, Many
        Yin(i) = Y(i)*tmp
        Zin(i) = H(i)*zscl
  230 CONTINUE
      Mold = Many
  240 CALL DIGLINE(Y,H,Many,1,0,2)
      CALL NEWPEN(Lblclr)
      Iarow(2) = 1
      CALL PLOT(Dlen,0.0,2)
      CALL PLOT(0.0,0.0,2)
      CALL PLOT(0.0,Zlen,2)
      CALL PLOT(Yin(1),Zlen,2)
      IF (Parm.EQ.1) THEN
        xposn = Dlen + XLOC(ptwd,siz3)
        yposn = -siz3hf - siz3
        CALL NUMBER(xposn,yposn,siz3,ptwd,0.0,-1)
        CALL NUMBER(-siz3hf,yposn,siz3,0.0,0.0,-1)
        xposn = -siz3hf - 2.0*siz3 + 2.0*XLOC(Slow,siz3)
        CALL NUMBER(xposn,-siz3hf,siz3,Slow,0.0,1)
        xposn = -siz3hf - 2.0*siz3 + 2.0*XLOC(Slow+Amaxp,siz3)
        yposn = Zlen - siz3hf
        CALL NUMBER(xposn,yposn,siz3,Slow+Amaxp,0.0,1)
      ENDIF
      IF (loop.EQ.1) THEN
        Iarow(1) = Iarow(2)
        RETURN 1
      ELSEIF (Parm.EQ.1) THEN
        ythal = Y(Loct)
        hthal = H(Loct)
        RETURN 1
      ENDIF
  250 IF (Iarow(1).NE.0) THEN
        xpos = ythal/yscale - ytrans - cost*0.5
        ypos = hthal/zscale - ztrans - sint*0.5
        CALL PLOT(xpos,ypos,3)
        xpos = ythal/yscale - ytrans
        ypos = hthal/zscale - ztrans
        CALL PLOT(xpos,ypos,2)
        xpos = xpos - sina
        ypos = ypos - cosa
        CALL PLOT(xpos,ypos,2)
      ENDIF
      ythal = Y(Loct)
      hthal = H(Loct)
      Iarow(1) = Iarow(2)
      xpos = Dlen - ytrans + 0.25
      ypos = -ztrans
      CALL PLOT(xpos,ypos,3)
      xpos = xpos + 0.5
      CALL PLOT(xpos,ypos,2)
      tmp = Idsd - Diff
      xpos = xpos + siz3
      ypos = ypos - siz3hf
      CALL NUMBER(xpos,ypos,siz3,tmp,0.0,-1)
      xpos = Dlen - ytrans + 0.5
      ypos = -ztrans
      CALL PLOT(xpos,ypos,3)
      xpos = Dlen + 0.5
      ypos = 0.0
      CALL PLOT(xpos,ypos,2)
      xpos = Dlen + 0.7 - ytrans*0.5 + siz3
      ypos = -ztrans*0.5
      inum = IFIX(ALOG10(Diff)) + 1
      tmp = inum*siz3hf
      xpos = xpos - cost*tmp
      ypos = ypos - sint*tmp
      CALL NUMBER(xpos,ypos,siz3,Diff,Thedeg,-1)
      IF (Parm.NE.ibnd(indx)) RETURN 1
      xpos = Dlen + 0.25
      ypos = 0.0
      CALL PLOT(xpos,ypos,3)
      xpos = xpos + 0.5
      CALL PLOT(xpos,ypos,2)
      tmp = Idsd
      xpos = xpos + siz3
      ypos = ypos - siz3hf
      CALL NUMBER(xpos,ypos,siz3,tmp,0.0,-1)
      IF (Iarow(2).NE.0) THEN
        xpos = ythal/yscale - cost*0.5
        ypos = hthal/zscale - sint*0.5
        CALL PLOT(xpos,ypos,3)
        xpos = ythal/yscale
        ypos = hthal/zscale
        CALL PLOT(xpos,ypos,2)
        xpos = xpos - sina
        ypos = ypos - cosa
        CALL PLOT(xpos,ypos,2)
      ENDIF
      IF (Parm.EQ.Inxs) THEN
        CALL NXTPLT()
        RETURN 1
      ELSE
        IF (Nstage.NE.0) THEN
          CALL NXTPLT()
          CALL PLOT(4.0,2.0,-3)
          CALL FACTOR(0.2)
          CALL NEWPEN(Lblclr)
        ELSE
          xpos = Dlen - cost*lrch(indx)/xscale + 3.0 + (Thedeg-90.)
     &           /(-7.5)
          CALL PLOT(xpos-0.5,-yorgin,-3)
        ENDIF
        loop = 1
        indx = indx + 1
        yorgin = 0.0
        GOTO 220
      ENDIF
  260 CALL ERRPRT(ierr)
      RETURN 2
      END
C
      SUBROUTINE HIDPT(YTRANS,ZTRANS,*)
      INCLUDE 'cgdims.cmn'
      INCLUDE 'comhid.cmn'
      INCLUDE 'comany.cmn'
      REAL yold(MXPTS2), zold(MXPTS2), YTRANS, ZTRANS, XINP, SLOPE, 
     &     CONST, b, bi, bj, bo, s, so, si, sj, xpos, xposir, ypos, yu, 
     &     yposil, zu, yn1, yposir, yposjl, yposjr, x1, y1, xu, x2, y2
      INTEGER i, j, isee, id, jd
      XINP(x1,y1,xu,x2,y2) = (x2-x1)*(xu-y1)/(y2-y1) + x1
      SLOPE(x1,y1,x2,y2) = (y2-y1)/(x2-x1)
      CONST(x1,y1,s) = y1 - s*x1
      DO 10 i = 1, Mold
        yold(i) = Yin(i) - YTRANS
        zold(i) = Zin(i) - ZTRANS
   10 CONTINUE
      yu = 1.00/Y(Many+2)
      zu = 1.00/H(Many+2)
      DO 20 i = 1, Many
        Yin(i) = Y(i)*yu
        Zin(i) = H(i)*zu
   20 CONTINUE
      IF (Zin(Loct).GE.zold(1)) THEN
        CALL DIGLINE(Y,H,Many,1,0,2)
        GOTO 90
      ENDIF
      CALL PLOT(Yin(1),Zin(1),3)
      id = 2
      yn1 = Yin(1)
      DO 30 j = 1, Mold
        IF (yold(j).GE.yn1) THEN
          jd = j - 1
          GOTO 40
        ENDIF
   30 CONTINUE
      jd = Mold
C
   40 IF (jd.EQ.0) jd = 1
      si = 9999999.0
      IF (yn1.NE.Yin(2)) si = SLOPE(yn1,Zin(1),Yin(2),Zin(2))
      bi = CONST(yn1,Zin(1),si)
      so = si
      bo = bi
      yposil = Zin(1)
      yposir = Zin(2)
      xposir = yn1
      yposjl = zold(jd)
C
   50 DO 70 j = jd, Mold
        IF (yold(j).GE.Yin(id)) THEN
C
   60     IF (j.NE.jd) THEN
            sj = 9999999.0
            IF (yold(jd).NE.yold(jd+1))
     &          sj = SLOPE(yold(jd),zold(jd),yold(jd+1),zold(jd+1))
            bj = CONST(yold(jd),zold(jd),sj)
            jd = jd + 1
          ENDIF
          IF (yold(jd).GT.xposir .AND. Yin(id).LE.yold(jd)) THEN
            yposir = Zin(id)
            xposir = Yin(id)
            yposjr = sj*Yin(id) + bj
            so = si
            bo = bi
            si = 9999999.0
            IF (Yin(id).NE.Yin(id+1))
     &          si = SLOPE(Yin(id),Zin(id),Yin(id+1),Zin(id+1))
            bi = CONST(Yin(id),Zin(id),si)
            id = id + 1
          ELSE
            yposir = si*yold(jd) + bi
            xposir = yold(jd)
            yposjr = zold(jd)
          ENDIF
          IF (yposil.GT.yposjl .AND. yposir.LT.yposjr .OR. 
     &        yposil.LT.yposjl .AND. yposir.GT.yposjr) THEN
            IF (xposir.NE.Yin(id-1)) THEN
              s = si
              b = bi
            ELSE
              s = so
              b = bo
            ENDIF
            IF (sj.NE.0.0) THEN
              zu = (b-bj)/sj/(1.0-s/sj)
              yu = s*zu + b
            ELSE
              yu = bj
              zu = (yu-b)/s
            ENDIF
            isee = 3
            IF (yposil.GT.yposjl) isee = 2
            CALL PLOT(zu,yu,isee)
            IF (isee.EQ.2) isee = 3
            IF (isee.EQ.3) isee = 2
          ELSE
            IF (yposil.LE.yposjl .AND. yposir.LE.yposjr) isee = 3
            IF (yposil.GE.yposjl .AND. yposir.GE.yposjr) isee = 2
          ENDIF
          CALL PLOT(xposir,yposir,isee)
          yposil = yposir
          yposjl = yposjr
          IF (xposir.EQ.Yin(Loct) .AND. isee.EQ.3) Iarow(2) = 0
          IF (xposir.NE.yold(j)) GOTO 60
          GOTO 50
        ENDIF
   70 CONTINUE
      DO 80 i = id, Many
        CALL PLOT(Yin(i),Zin(i),2)
   80 CONTINUE
C
   90 CALL PLOT(Dlen,0.0,2)
      CALL PLOT(Dlen-YTRANS,0.0,2)
      isee = 3
      j = Mold
C
  100 IF (zold(j).LE.0.0) THEN
        IF (zold(j).EQ.zold(j+1)) zold(j) = zold(j) + 0.1
        xpos = XINP(yold(j),zold(j),0.0,yold(j+1),zold(j+1))
        CALL PLOT(xpos,0.0,isee)
        isee = 2
C
  110   j = j - 1
        IF (j.EQ.0) GOTO 120
        IF (zold(j).LT.0.0) GOTO 110
        IF (zold(j).EQ.zold(j+1)) zold(j) = zold(j) + 0.1
        xpos = XINP(yold(j),zold(j),0.0,yold(j+1),zold(j+1))
        IF (xpos.LT.0.0) xpos = 0.0
        CALL PLOT(xpos,0.0,isee)
        isee = 3
      ENDIF
      j = j - 1
      IF (j.NE.0) GOTO 100
C
  120 CALL PLOT(0.0,0.0,isee)
      IF (isee.NE.2) THEN
        DO 130 i = 1, Mold
          IF (yold(i).GT.0.0) THEN
            j = i
            GOTO 140
          ENDIF
  130   CONTINUE
        j = Mold
C
  140   s = 9999999.0
        IF (j.LT.2) THEN
          ypos = zold(1)
        ELSE
          IF (yold(j-1).NE.yold(j)) s = SLOPE(yold(j-1),zold(j-1), 
     &                                  yold(j),zold(j))
          ypos = CONST(yold(j),zold(j),s)
          IF (ypos.LT.0.0) ypos = 0.0
        ENDIF
        CALL PLOT(0.0,ypos,3)
      ENDIF
      CALL PLOT(0.0,Zlen,2)
      CALL PLOT(Yin(1),Zlen,2)
      Mold = Many
      RETURN 1
      END
