      SUBROUTINE STNDFL(LE431,DEFFMT,FORM)
C
C  Last modified December 8, 1992 -- RSR
C  modified Febuary 3, 1992 -- RSR
C
      INCLUDE 'cgdims.cmn'
      INCLUDE 'comany.cmn'
      INCLUDE 'cgcctl.cmn'
      INCLUDE 'cgunit.cmn'
      INCLUDE 'comsbd.cmn'
      LOGICAL LE431, found
      INTEGER i, nsta
      CHARACTER ctst*2, DEFFMT*26, FORM*60
      CHARACTER*80 ident(MAXCOM)
      REAL zmin, zinc, dinc, ainc, winc, fslope, mangsn
C
C CREATE STANDARD FORMAT FILE:  SORT DATA AND ELIMINATE DUPLICATIONS
C THE VARIABLE CARD IS USED AS AN INTERNAL FILE TO STORE THE INPUT RECORD
C IN FORTRAN 77 AFTER EACH READ FROM OR WRITE TO AN INTERNAL FILE THE
C FILE IS AUTOMATICALLY REWOUND, REPLACING THE CALL TO CORE.
C
   10 READ (Kdev,9020,END=20) ctst
      IF (ctst.NE.'  ') THEN
C
        BACKSPACE Kdev
        CALL READXS(nsta,zmin,zinc,dinc,ainc,winc,fslope,mangsn,ident,
     &              LE431,FORM,Kdev,Idev,found)
        IF (found) THEN
C
C     WRITE RECORDS FOR THIS CROSS SECTION TO STANDARD FILE
C
          WRITE (Stndrd,9010) nsta, Ncom, zmin, Zmax, Deltaz, Deg, Ndsd, 
     &                        Mn1, Mn2, Dacorr, zinc, dinc, Nsubs, ainc, 
     &                        winc, Many, fslope, mangsn
          IF (Ncom.NE.0) WRITE (Stndrd,9015) (ident(i),i=1,Ncom)
          IF (Nsubs.NE.0) WRITE (Stndrd,9005) (Subd(i),i=1,MXSUBS), 
     &                           (Subman(i),i=1,MXSUB1)
          WRITE (Stndrd,DEFFMT) (Y(i),H(i),i,i=1,Many)
          WRITE (Stndrd,DEFFMT)
          GOTO 10
        ENDIF
      ENDIF
C
C     FINISHED READING INPUT DATA FOR EACH CROSS SECTION.
C
   20 RETURN
 9005 FORMAT (2X,6F8.2,7F8.4)
 9010 FORMAT (I2,2X,I1,3(F7.2),F3.0,I6,1X,2I2,F8.2,2(1X,F6.1),1X,I1,
     &        2(F6.1),I4,F6.4,F6.3)
 9015 FORMAT (A80)
 9020 FORMAT (A2)
      END
