      SUBROUTINE SUBDIV(ZS,ZMAX,NSUBS,DELTA,NSTA,NDSD,ALTPCH,ZZMIN,
     &                  FSLOPE,*,*)
      INCLUDE 'cgdims.cmn'
      INCLUDE 'comany.cmn'
      INCLUDE 'cgunit.cmn'
      INCLUDE 'comsbd.cmn'
      INCLUDE 'comawp.cmn'
      INTEGER iawp(MXCMP2,MXSUB4), mtemp, indx, mindx, ic, initfl, 
     &        numsub, iwidth(MXCPP2), i, j, k, l, jj, kk, ierr, iup, 
     &        NSUBS, ia(MXCPSB), ALTPCH, NSTA, NDSD, iii
      REAL ytemp(MXPTS2), htemp(MXPTS2), sstag(MXCPP2), tmp, 
     &     subout(MXSUBS+2), YINP, ZS(MXPTS2), ZMAX, DELTA, x1, y1, yy, 
     &     x2, y2, FSLOPE, hydrad, ZZMIN, tarea, tdish, twidh, rnd, 
     &     thalwg, zwall(MXSUBS), wall, wp, twetp, slope, rmansn, convey
      LOGICAL sflag
      CHARACTER prtlb2*11, prtlbl*12, tform(7)*14, tform2(7)*20, 
     &          prtlb3*27
      SAVE iawp, sstag, ytemp, htemp, subout, initfl, sflag, numsub, 
     &  iup, mindx, mtemp, ic, thalwg, zwall, rnd, rmansn
      EQUIVALENCE (iawp(1,1),ia(1))
      DATA prtlbl/'SUBDIVISION'/, prtlb2/'AREA  WIDTH'/, 
     &     prtlb3/'  AREA  WIDTH  DISCH  WETP'/
      DATA tform/' (''+'',T15,2I6)', ' (''+'',T32,2I6)', 
     &     ' (''+'',T49,2I6)', ' (''+'',T66,2I6)', ' (''+'',T83,2I6)', 
     &     '(''+'',T100,2I6)', '(''+'',T117,2I6)'/
      DATA tform2/' (''+'',T13,2I6,I7,I6)', ' (''+'',T42,I6,2I7,I6)', 
     &     ' (''+'',T71,I6,2I7,I6)', '(''+'',T100,I6,2I7,I6)', 
     &     '(''+'',T129,I6,2I7,I6)', '(''+'',T157,I6,2I7,I6)', 
     &     '(''+'',T186,I6,2I7,I6)'/
      DATA mtemp/0/, sflag/.FALSE./, numsub/0/, iup/0/, mindx/0/, 
     &     initfl/1/, ic/1/
      YINP(x1,y1,yy,x2,y2) = y2 - (y2-y1)*(x2-yy)/(x2-x1)
      slope = SQRT(FSLOPE)
      IF (initfl.EQ.1) THEN
        IF (NSUBS.GT.MXSUBS) THEN
          ierr = 29
          GOTO 200
        ENDIF
        initfl = 2
        thalwg = 9999999.0
        mindx = 0
        numsub = NSUBS + 1
        CALL MOVEI0(ia,MXCPSB)
        CALL MOVE0(zwall,MXSUBS)
C       Sort subdivisions points and manning's N values (last Manning's value
C       must be in correct order)
        DO 20 i = 1, NSUBS - 1
          DO 10 j = 1, NSUBS - i
            IF (Subd(j).GE.Subd(j+1)) THEN
              tmp = Subd(j)
              Subd(j) = Subd(j+1)
              Subd(j+1) = tmp
              tmp = Subman(j)
              Subman(j) = Subman(j+1)
              Subman(j+1) = tmp
            ENDIF
   10     CONTINUE
   20   CONTINUE
        DO 30 i = 1, Many
          ytemp(i) = Y(i)
          htemp(i) = ZS(i)
   30   CONTINUE
        mtemp = Many
        Savmax = ZMAX
        tmp = Savmax + DELTA
        DO 40 i = 1, MXCMP2
          sstag(i) = tmp - DELTA*i
   40   CONTINUE
        Hmax = ZS(1)
        IF (ZS(Many).GT.Hmax) Hmax = ZS(Many)
        subout(1) = Y(1)
        DO 50 i = 1, NSUBS
          subout(i+1) = Subd(i)
   50   CONTINUE
        subout(NSUBS+2) = Y(Many)
        IF (ALTPCH.EQ.0) WRITE (Sbdunt,9075) NSTA
      ELSE
        rnd = DELTA*0.05
        IF (ZZMIN.LT.thalwg) thalwg = ZZMIN
        l = 1
        IF (ALTPCH.EQ.0) WRITE (Sbdunt,9030) prtlbl, ic, subout(ic), 
     &                          subout(ic+1)
        indx = IFIX((ZMAX-Zmin)/DELTA+2.5)
        kk = MXCMP2 + 1
        IF (indx.GT.kk) THEN
          iup = indx - kk
          Zmin = Zmin + (iup*DELTA)
          indx = kk
        ENDIF
        IF (indx.GT.mindx) mindx = indx
        Jflag = 0
        Ym = 0
        Yl = 0
        Area = 0.0
        Width = 0.0
        rmansn = 0.0
        IF (Subman(ic).GT.0.0) rmansn = (1.486/Subman(ic))*slope
   60   CALL CALAWP
C
C COMBINE AREA OF MAIN CHANNEL AND AREA OF SUBCHANNELS
        Xarea(l) = Area + Altc + Artc
        iwidth(l) = IFIX(Width+Ym-Yl+Wltc+Wrtc+0.5)
        iii = indx - l
        iawp(iii,4*ic-3) = IFIX(Xarea(l)+0.5)
        iawp(iii,4*ic-2) = iwidth(l)
        IF (ALTPCH.EQ.1) THEN
C         Subtract imaginary wall(s) from subdivision wetted perimeters
          wall = 0.0
          IF (ic.LE.NSUBS .AND. sstag(iii).GT.zwall(ic))
     &        wall = (sstag(iii)-zwall(ic))
          IF (ic.GT.1 .AND. sstag(iii).GT.zwall(ic-1)) wall = wall + 
     &        (sstag(iii)-zwall(ic-1))
          wp = Wetp + Wpltc + Wprtc - wall
          IF (wp.GT.0.01) THEN
            hydrad = (Xarea(l)/wp)**0.6667
          ELSE
            hydrad = 0.0
          ENDIF
          tmp = rmansn*Xarea(l)*hydrad
          iawp(iii,4*ic-1) = IFIX(tmp+0.5)
          iawp(iii,4*ic) = IFIX(wp+0.5)
        ENDIF
        S = S + DELTA
        IF (S.LT.ZMAX .OR. S-ZMAX.LT.rnd) THEN
CC        IF ( ZS(1).LT. S ) write(*,*) 'ZS(1)',ZS(1),S
CC        IF ( ZS(Many).LT. S ) write(*,*) 'ZS(Many)',ZS(Many),S
          IF (ZS(1).LT.S) ZS(1) = S
          IF (ZS(Many).LT.S) ZS(Many) = S
          l = l + 1
          Jflag = 1
          IF (l.LE.MXCOMP) GOTO 60
        ENDIF
        IF (ALTPCH.EQ.0) THEN
          DO 70 i = l, 1, -1
            WRITE (Sbdunt,9025) sstag(l-i+1), IFIX(Xarea(i)+0.5), 
     &                          iwidth(i)
   70     CONTINUE
        ENDIF
        ic = ic + 1
      ENDIF
      IF ((ic.GT.numsub) .OR. sflag) THEN
        IF (sflag) NSUBS = 0
        IF (ALTPCH.EQ.0) THEN
          WRITE (Iprt,9010) (prtlbl,j,j=1,numsub)
          WRITE (Iprt,9020) (subout(j),subout(j+1),j=1,numsub)
          WRITE (Iprt,9015) (prtlb2,j=1,numsub)
          WRITE (Iprt,9005)
          DO 90 i = 1, mindx - 1
            WRITE (Iprt,9035) sstag(i)
            DO 80 j = 1, numsub
              IF (iawp(i,j*4-2).NE.0) WRITE (Iprt,tform(j))
     &            (iawp(i,k),k=j*4-3,j*4-2)
   80       CONTINUE
   90     CONTINUE
        ELSE
          WRITE (Iprt,9050) (prtlbl,j,j=1,numsub)
          WRITE (Iprt,9060) (subout(j),subout(j+1),j=1,numsub)
          WRITE (Iprt,9085) ('Manning''s:',Subman(j),j=1,numsub)
          WRITE (Iprt,9055) (prtlb3,j=1,numsub)
          WRITE (Iprt,9005)
          WRITE (Sbdunt,9070) NSTA, mindx, NDSD, thalwg
          DO 110 i = mindx - 1, 1, -1
            WRITE (Iprt,9035) sstag(i)
            tarea = 0.0
            twidh = 0.0
            tdish = 0.0
            twetp = 0.0
            DO 100 j = 1, numsub
              IF (iawp(i,j*4-2).NE.0) WRITE (Iprt,tform2(j))
     &            (iawp(i,k),k=j*4-3,j*4)
              tarea = tarea + iawp(i,j*4-3)
              twidh = twidh + iawp(i,j*4-2)
              tdish = tdish + iawp(i,j*4-1)
              twetp = twetp + iawp(i,j*4)
  100       CONTINUE
            IF (tdish.GT.0.99) THEN
              convey = tdish
              IF (slope.GT.0.0) convey = tdish/slope
              WRITE (Sbdunt,9065) sstag(i), tdish, tarea, twidh, twetp, 
     &                            convey
            ELSE
              IF (tarea.LT.rnd) tarea = twidh*DELTA
              IF (tdish.LT.rnd) tdish = rmansn*tarea*((tarea/twetp)**
     &                                  0.6667)
              convey = tdish
              IF (slope.GT.0.0) convey = tdish/slope
              WRITE (Sbdunt,9080) sstag(i), tdish, tarea, twidh, twetp, 
     &                            convey
            ENDIF
  110     CONTINUE
        ENDIF
        IF (iup.GT.0) WRITE (Iprt,9045)
        ic = 1
        initfl = 1
        RETURN 2
      ENDIF
      IF (ic.GT.1) THEN
        IF (ytemp(mtemp).GE.subout(ic+1)) THEN
          DO 120 j = 1, mtemp
            IF (ytemp(j).GT.subout(ic)) THEN
              jj = j
              GOTO 130
            ENDIF
  120     CONTINUE
          jj = mtemp + 1
  130     Y(1) = subout(ic)
          Y(2) = Y(1) + 0.0001
          ZS(2) = YINP(ytemp(jj-1),htemp(jj-1),Y(2),ytemp(jj),htemp(jj))
          ZS(1) = Hmax + 1.0
          j = jj - 3
          DO 140 k = 3, mtemp
            ZS(k) = htemp(j+k)
            Y(k) = ytemp(j+k)
            IF (ic.LT.numsub) THEN
              IF (Y(k).GE.Subd(ic)) THEN
                kk = k
                GOTO 150
              ENDIF
            ELSEIF (k+j.EQ.mtemp) THEN
              Many = k
              GOTO 180
            ENDIF
  140     CONTINUE
          kk = mtemp + 1
  150     k = kk
          j = j + k
        ELSE
          WRITE (*,*) 'ic,mtemp,y(mtemp),subout(ic+1),subout(ic)', ic, 
     &                mtemp, Y(mtemp), subout(ic+1), subout(ic)
          ierr = 27
          GOTO 200
        ENDIF
      ELSEIF (ytemp(1).LT.Subd(1)) THEN
        DO 160 j = 1, mtemp
          IF (ytemp(j).GT.Subd(ic) .OR. 
     &        (ytemp(j).EQ.Subd(ic) .AND. j.NE.mtemp)) THEN
            k = j
            GOTO 170
          ENDIF
  160   CONTINUE
        k = mtemp + 1
        WRITE (Iprt,9040)
        sflag = .TRUE.
  170   j = k
      ELSE
        ierr = 27
        GOTO 200
      ENDIF
      Many = k + 1
      Y(Many) = Subd(ic)
      Y(k) = Y(Many) - 0.0001
      ZS(k) = YINP(ytemp(j-1),htemp(j-1),Y(k),ytemp(j),htemp(j))
      ZS(Many) = Hmax + 1.0
      zwall(ic) = ZS(k)
  180 tmp = Hmax
      DO 190 l = 1, Many
        IF (ZS(l).LT.tmp) tmp = ZS(l)
  190 CONTINUE
      Zmin = tmp - AMOD(tmp,DELTA)
      ZMAX = Savmax
      Zmin = Zmin + AMOD(ABS(ZMAX),DELTA)
      RETURN 1
  200 CALL ERRPRT(ierr)
      STOP
C
 9005 FORMAT (1X)
 9010 FORMAT (14X,7(A12,I1,4X))
 9015 FORMAT (4X,'STAGE',T16,7(A11,6X))
 9020 FORMAT (11X,7(F7.1,' -',F7.1,1X))
 9025 FORMAT (F5.1,2I15)
 9030 FORMAT (/,3X,A12,I1,2X,'(',F8.1,' -',F8.1,')')
 9035 FORMAT (F10.2)
 9040 FORMAT (' ***WARNING - FIRST SUBDIVISION POINT IS PAST LEW ***')
 9045 FORMAT (
     &' ***SUBDIVISION TABLE BOUNDS EXCEEDED -- REMAINDER OF TABLE CANNO
     &T BE PRINTED')
 9050 FORMAT (3X,7(16X,A12,I1))
 9055 FORMAT (5X,'STAGE',T13,7(A,2X))
 9060 FORMAT (3X,7(F20.1,' -',F7.1))
 9065 FORMAT (F10.2,4F11.0,F12.0)
 9070 FORMAT (/,' Cross Section',I4,'  Values=',I4,'  Distance=',I8,/,
     &        4X,
     &  'Stage   Discharge    XS Area  Top Width  Perimeter  Conveyance'
     &  ,/,F10.2,4(9X,'0.'),10X,'0.')
 9075 FORMAT (/,5X,'CROSS SECTION NUMBER',I3)
 9080 FORMAT (F10.2,4F11.1,F12.0)
 9085 FORMAT (6X,7(11X,A,F8.5))
      END
