      SUBROUTINE XSPLOT
      REAL incr, top, size, rmax, rmin
      INTEGER n1, n2, lenyax, lenxax
C PLOT CROSS SECTIONS ON CALCOMP PLOTTER (OUTPUT OPTION 14)
      INCLUDE 'cgdims.cmn'
      INCLUDE 'comany.cmn'
      INCLUDE 'cgunit.cmn'
      INCLUDE 'comtdp.cmn'
      INCLUDE 'comax.cmn'
      size = 0.14
      lenyax = Leny
      lenxax = Lenx
      n1 = Many + 1
      n2 = Many + 2
      CALL CMINMX(H,Many,rmin,rmax)
      rmin = rmin + Zzmin
      rmax = rmax + Zzmin
      IF (Zinc.LT.0.0) THEN
        Hdrflg = 2
        incr = ABS(Zinc)
        Firval = rmin - AMOD(rmin,incr)
        IF (rmin.LT.Firval) Firval = Firval - incr
        top = rmax - AMOD(rmax,incr)
        IF (top.LT.rmax) top = top + incr
        lenyax = (top-Firval)/incr
        H(n2) = incr
        H(n1) = Firval - Zzmin
      ELSEIF (Zinc.GT.0.0) THEN
        Hdrflg = 1
        Firval = 0.0
        H(n2) = Zinc
        H(n1) = rmin - Zzmin
        rmax = rmax - Zzmin
        top = rmax - AMOD(rmax,Zinc)
        IF (top.LT.rmax) top = top + Zinc
        lenyax = top/Zinc
      ELSE
        Hdrflg = 2
        top = Hgtmax
        IF (top.LT.rmax) top = rmax
        H(n1) = Zzmin
        CALL SCALER(H(n2),top,H(n1),lenyax,1)
        Firval = H(n1)
        H(n1) = H(n1) - Zzmin
      ENDIF
      Delval = H(n2)
      IF (Dinc.GT.0.0) THEN
        Y(n1) = Y(1) - AMOD(Y(1),Dinc)
        IF (Y(n1).GT.Y(1)) Y(n1) = Y(n1) - Dinc
        top = Y(Many) - AMOD(Y(Many),Dinc)
        IF (top.LT.Y(Many)) top = top + Dinc
        lenxax = (top-Y(n1))/Dinc
        Y(n2) = Dinc
      ELSE
        Y(n1) = Distmn
        IF (Y(1).LT.Distmn) Y(n1) = Y(1)
        CALL SCALER(Y(n2),Distmx,Y(n1),lenxax,5)
      ENDIF
      Ylen = lenyax
      Xlen = lenxax
C
      IF ((.NOT.Pflag) .AND. Parm.EQ.1) CALL PLOTS(Pltunt,1,0)
C
      CALL PLOT(1.0,1.0,-3)
      CALL NEWPEN(Lblclr)
      CALL FACTOR(1.0)
      CALL SYMBOL((Xlen-38.0*size)*0.5,-.50,size,
     &            'DISTANCE FROM REFERENCE POINT, IN FEET',0.0,38)
      CALL DRAXIS(Y(n1),Y(n2),rmin,lenyax,lenxax,1)
      CALL DIGLINE(Y,H,Many,1,1,3)
      CALL NEWPEN(Lblclr)
      CALL PLTLBL(Nsta,lenyax)
      CALL NXTPLT()
      RETURN
      END
