      SUBROUTINE MNGRPV(INXS,*)
      INCLUDE 'cgdims.cmn'
      INCLUDE 'mngrps.cmn'
      INTEGER i, nn, j, INXS, k
C VALIDATE INPUT MEAN PAIRS
      j = 0
C
      DO 10 i = 1, INXS
        IF (Mnpr(1,i).NE.0 .OR. Mnpr(2,i).NE.0) THEN
          IF (Mnpr(1,i).LT.0 .OR. Mnpr(2,i).LT.0) THEN
            CALL ERRPRT(18)
            RETURN 1
          ENDIF
          j = j + 1
          IF (Mnpr(1,i).EQ.0 .AND. Mnpr(2,i).NE.0) THEN
            Mnpr(1,i) = Mnpr(2,i)
            Mnpr(2,i) = 0
          ENDIF
          IF (Mnpr(1,i).EQ.Mnpr(2,i)) Mnpr(2,i) = 0
        ENDIF
   10 CONTINUE
C
      IF (j.EQ.0) THEN
        DO 20 i = 1, INXS
          Mnpr(1,i) = i
   20   CONTINUE
      ENDIF
C
C  INITIALIZE MEANS ARRAYS
      nn = MXGRPS*MXTBLE
      CALL MOVE0(Zstg,nn)
      CALL MOVE0(Arsum,nn)
      CALL MOVE0(Wpsum,nn)
      CALL MOVE0(Hrsum,nn)
      CALL MOVE0(Wdsum,nn)
      CALL MOVE0(Qsum,nn)
      CALL MOVEI0(Isum,nn)
      nn = MXGRPS
      CALL MOVEI0(Mnct,nn)
      CALL MOVEI0(Nstor,nn)
      CALL MOVEVL(Zmn,nn,9999999.0)
      CALL MOVEI0(Lenflw,nn)
      CALL MOVE0(Slopes,nn)
      CALL MOVE0(Thalwg,nn)
C
C STORE CROSS SECTIONS AND DETERMINE ZMN TO COMPUTE MEANS
C
      DO 40 i = 1, MXGRPS
        j = 0
        DO 30 k = 1, INXS
          IF (Mnpr(1,k).EQ.i .OR. Mnpr(2,k).EQ.i) THEN
            Thalwg(i) = Thalwg(i) + Zzmnn(k)
            IF (Zmn(i).GT.Zmnn(k)) Zmn(i) = Zmnn(k)
            j = j + 1
            Nxs(j,i) = Nxsect(k)
          ENDIF
   30   CONTINUE
        IF (j.NE.0) Thalwg(i) = Thalwg(i)/FLOAT(j)
   40 CONTINUE
      RETURN
      END
C
      SUBROUTINE MINXS7(IOPT,SLOW,HGTMAX,DISTMN,DISTMX,INXS,NXPOS,NSET)
C
C     DETERMINE ABSOLUTE MINIMUM STAGE (SLOW) AND NUMBER OF CROSS SECTIONS
C     (INXS) FOR OUTPUT OPTION 7
C
      INCLUDE 'cgdims.cmn'
      INCLUDE 'prmalt.cmn'
      INCLUDE 'cgunit.cmn'
      INCLUDE 'comany.cmn'
      INTEGER i, nsta, ncom, nsubs, INXS, NXPOS, NSET, idmy1, idmy2, 
     &        IOPT
      REAL SLOW, HGTMAX, DISTMN, DISTMX, dacorr, rmin, rmax, zmin, zmax
      LOGICAL flg
      flg = .TRUE.
      IF (NXPOS.NE.0) flg = .FALSE.
      INXS = 0
      SLOW = 9999999.0
      HGTMAX = -9999999.0
      DISTMN = 9999999.0
      DISTMX = -9999999.0
   10 READ (Idev,'(I2,2X,I1,2F7.2,T41,F8.2,T64,I1,T77,I4)',END=60) nsta, 
     &      ncom, zmin, zmax, dacorr, nsubs, Many
      DO 20 i = 1, ncom
        READ (Idev,9005)
   20 CONTINUE
      IF (nsubs.NE.0) READ (Idev,9005)
      DO 30 i = 1, Npar
        IF (nsta.EQ.Nxsec(i)) dacorr = Datm(i)
   30 CONTINUE
      DO 40 i = 1, Many
        READ (Idev,9005) Y(i), H(i)
   40 CONTINUE
      READ (Idev,9005)
C
      IF (nsta.EQ.NXPOS) flg = .TRUE.
      IF (flg) THEN
        IF (INXS.EQ.NSET) GOTO 60
        INXS = INXS + 1
        IF (IOPT.EQ.14) THEN
          IF (zmin.EQ.0.0) zmin = H(Many/2)
          IF (zmax.EQ.0.0) zmax = H(1)
          CALL XTRPBN(zmax,zmin,IOPT,.FALSE.,idmy1,idmy2,*50)
        ENDIF
   50   CALL CMINMX(Y,Many,rmin,rmax)
        IF (rmin.LT.DISTMN) DISTMN = rmin
        IF (rmax.GT.DISTMX) DISTMX = rmax
        CALL CMINMX(H,Many,rmin,rmax)
        rmin = rmin + dacorr
        rmax = rmax + dacorr
        IF (rmin.LT.SLOW) SLOW = rmin
        IF (rmax.GT.HGTMAX) HGTMAX = rmax
      ENDIF
      GOTO 10
C
   60 REWIND Idev
      RETURN
 9005 FORMAT (T15,F8.1,T26,F8.2)
      END
C
      SUBROUTINE MINSTG(Z,MANY,ZZMIN,ZMIN,ZMAX,DELTA,IOPT,L,J,*)
      INTEGER J, limit, k, i, n, kk, ierr, L, MANY, IOPT, ii
      REAL ZZMIN, ZMIN, ZMAX, DELTA, Z(MANY)
      LOGICAL subdlt
C
C CHECK MIMIMUM STAGE REQUIREMENTS
C
      J = 0
      subdlt = .FALSE.
   10 IF (ZZMIN.GE.ZMIN) THEN
        J = 1
C J = 1:  NO STAGE READINGS BELOW MINIMUM STAGE
        limit = IFIX((ZMAX-ZMIN)/DELTA)
        DO 20 k = 1, limit
          ZMIN = ZMIN + DELTA
          IF (IOPT.EQ.15) L = L + 1
          IF (ZZMIN.LT.ZMIN) GOTO 30
   20   CONTINUE
        ierr = 16
        GOTO 70
      ENDIF
   30 limit = MANY - 1
      DO 60 k = 1, limit
        kk = k + 1
        IF (Z(k).LT.ZMIN .AND. Z(kk).LT.ZMIN) THEN
C
          n = kk + 1
          IF (n.GT.MANY) RETURN
          DO 50 i = n, MANY
            IF (Z(i).GE.ZMIN) THEN
              n = i + 1
              IF (n.GT.MANY) RETURN
C
              DO 40 ii = n, MANY
                IF (Z(ii).LT.ZMIN) THEN
                  J = 3
C  J = 3:  TWO CHANNELS AT MINIMUM STAGE
                  IF (ZMIN.LT.ZMAX) THEN
                    ZMIN = ZMIN + DELTA
                    IF (IOPT.EQ.15) L = L + 1
                    GOTO 30
                  ELSE
                    ierr = 28
                    GOTO 70
                  ENDIF
                ENDIF
   40         CONTINUE
              RETURN
            ENDIF
   50     CONTINUE
          ZMIN = ZMIN - DELTA
          subdlt = .TRUE.
          GOTO 10
        ENDIF
   60 CONTINUE
      ZMIN = ZMIN + DELTA
      IF (subdlt) THEN
        ierr = 16
        GOTO 70
      ENDIF
      IF (IOPT.EQ.15) L = L + 1
      IF (J.EQ.0) J = 2
C J = 2:  JUST ONE STAGE READING BELOW MINIMUM STAGE
      GOTO 30
C
   70 CALL ERRPRT(ierr)
      RETURN 1
      END
C
      SUBROUTINE CMINMX(A,N,RMIN,RMAX)
      INTEGER N, i
      REAL A(N), RMIN, RMAX
      RMIN = A(1)
      RMAX = RMIN
      DO 10 i = 2, N
        IF (A(i).GT.RMAX) RMAX = A(i)
        IF (A(i).LT.RMIN) RMIN = A(i)
   10 CONTINUE
      RETURN
      END
C
      SUBROUTINE DRAXIS(FIRSTX,DELTAX,ZZMIN,LENYAX,LENXAX,MFLAG)
      REAL FIRSTX, DELTAX, ZZMIN, xpos, ypos, xnum, ticm, XLOC
      INTEGER MFLAG, LENYAX, i, LENXAX
      CHARACTER*28 msg
      INCLUDE 'comax.cmn'
      xpos = 0.0
      CALL PLOT(xpos,0.0,3)
      CALL PLOT(xpos,+0.07,2)
      CALL NUMBER(XLOC(FIRSTX,0.105),-0.21,0.105,FIRSTX,0.0,-1)
      CALL PLOT(xpos,0.0,3)
      DO 10 i = 1, LENXAX
        xpos = xpos + 1.0
        CALL PLOT(xpos,0.0,2)
        CALL PLOT(xpos,+0.07,2)
        xnum = i*DELTAX + FIRSTX
        CALL NUMBER(xpos+XLOC(xnum,0.105),-0.21,0.105,xnum,0.0,-1)
        CALL PLOT(xpos,0.0,3)
   10 CONTINUE
      IF (MFLAG.EQ.1) THEN
        WRITE (msg,9005) ZZMIN
        xpos = Xlen - 2.7
        CALL SYMBOL(xpos,0.12,0.1,msg,0.0,26)
      ENDIF
      ticm = Xlen - 0.07
      ypos = 0.0
      CALL PLOT(Xlen,ypos,3)
      DO 20 i = 1, LENYAX
        ypos = ypos + 1.0
        CALL PLOT(Xlen,ypos,2)
        CALL PLOT(ticm,ypos,2)
        CALL PLOT(Xlen,ypos,3)
   20 CONTINUE
      ticm = Ylen - 0.07
      xpos = Xlen
      DO 30 i = 1, LENXAX
        xpos = xpos - 1.0
        CALL PLOT(xpos,Ylen,2)
        CALL PLOT(xpos,ticm,2)
        CALL PLOT(xpos,Ylen,3)
   30 CONTINUE
      ypos = LENYAX
      CALL PLOT(0.0,ypos,3)
      ticm = +0.07
      DO 40 i = 1, LENYAX
        CALL PLOT(ticm,ypos,2)
        CALL PLOT(0.0,ypos,3)
        ypos = ypos - 1.0
        CALL PLOT(0.0,ypos,2)
   40 CONTINUE
      CALL PLOT(ticm,ypos,2)
C
      RETURN
 9005 FORMAT ('THALWEG ELEVATION:',F8.2)
      END
C
      SUBROUTINE ERRPRT(ICODE)
      INTEGER ICODE, ic
      INCLUDE 'errcmn.cmn'
      INCLUDE 'cgunit.cmn'
      WRITE (Iprt,9005) ICODE
      WRITE (*,9005) ICODE
      IF (ICODE.LT.12) THEN
        WRITE (Iprt,9010) Errmes(ICODE)
        WRITE (*,9010) Errmes(ICODE)
      ELSEIF (ICODE.LT.23) THEN
        ic = ICODE - 11
        WRITE (Iprt,9010) Ermes1(ic)
        WRITE (*,9010) Ermes1(ic)
      ELSEIF (ICODE.LT.34) THEN
        ic = ICODE - 22
        WRITE (Iprt,9010) Ermes2(ic)
        WRITE (*,9010) Ermes2(ic)
      ELSE
        ic = ICODE - 33
        WRITE (Iprt,9010) Ermes3(ic)
        WRITE (*,9010) Ermes3(ic)
      ENDIF
      RETURN
 9005 FORMAT (1X,'***** ERROR MESSAGE ',I2,' *****')
 9010 FORMAT (A80)
      END
C
      SUBROUTINE PLTLBL(NSTA,LENYAX)
      INTEGER NSTA, i, k, LENYAX
      REAL ypos, xpos, xp, size, XLOC, yorg
      INCLUDE 'comax.cmn'
      INCLUDE 'comdat.cmn'
      yorg = Firval
      size = 0.14
      ypos = -0.0525
      xp = 999.0
      DO 10 i = 1, LENYAX + 1
        k = 3
        IF (ABS(yorg).GT.1.0) k = k + IFIX(ALOG10(ABS(yorg)+0.0005))
        IF (IFIX(yorg).LT.0) k = k + 1
        xpos = -0.08 - ((0.105)*k)
        IF (xpos.LT.xp) xp = xpos
        CALL NUMBER(xpos,ypos,0.105,yorg,0.0,1)
        yorg = yorg + Delval
        ypos = ypos + 1.0
   10 CONTINUE
C
      xpos = xp - 1.5*size
      ypos = Ylen*0.5
      IF (Hdrflg.EQ.1) THEN
        CALL SYMBOL(xpos,ypos-16.0*size,size,
     &              'ELEVATION ABOVE THALWEG, IN FEET',90.0,32)
      ELSEIF (Hdrflg.EQ.2) THEN
        CALL SYMBOL(xpos,ypos-9.*size,size,'ELEVATION, IN FEET',90.,18)
      ELSE
        CALL SYMBOL(xpos,ypos-7.*size,size,'STAGE, IN FEET',90.,14)
      ENDIF
C
      xpos = (Xlen-44.0*0.21)*0.5
      ypos = Ylen + size
      DO 20 i = 1, 22
        CALL SYMBOL(xpos,ypos,0.21,Ibcd(i),0.0,1)
        xpos = xpos + 0.42
   20 CONTINUE
      xpos = (Xlen-16.0*size)*0.5
      ypos = Ylen - 2.0*size
      CALL SYMBOL(xpos,ypos,size,'CROSS SECTION ',0.0,14)
      xpos = xpos + (size*14)
      CALL NUMBER(xpos,ypos,size,FLOAT(NSTA),0.0,-1)
      ypos = ypos - .17
      IF (Daref.EQ.0.0) THEN
        xpos = (Xlen-2.2)*0.5
        CALL SYMBOL(xpos,ypos,0.10,'DATUM IS',0.0,8)
        xpos = xpos + 0.9
      ELSE
        xp = XLOC(Daref,0.10)
        xpos = (Xlen*0.5) + xp - 1.80
        CALL SYMBOL(xpos,ypos,0.10,'DATUM IS ',0.0,9)
        xpos = xpos + 0.9
        CALL NUMBER(xpos,ypos,.10,ABS(Daref),0.0,2)
        xpos = xpos + ABS(xp*2.0-.30)
        IF (Daref.LT.0.0) THEN
          CALL SYMBOL(xpos,ypos,.10,' FT. BELOW',0.0,10)
        ELSE
          CALL SYMBOL(xpos,ypos,.10,' FT. ABOVE',0.0,10)
        ENDIF
        xpos = xpos + 1.10
      ENDIF
      CALL SYMBOL(xpos,ypos,0.10,Dtmnam,0.0,20)
      RETURN
      END
C
      SUBROUTINE SCALER(RESULT,MAXI,MINI,NUMBER,INC)
      REAL MAXI, MINI, fact(9), RESULT, one, ratio, dmy, chk, divi
      INTEGER NUMBER, INC, i
      DATA one/1.0/
      ratio = ABS((MAXI-MINI)/NUMBER)
C
C     CALCULATE STAGE SCALE
      IF (NUMBER.EQ.50 .AND. INC.EQ.2) THEN
        divi = 0.1
        i = IFIX(ratio*10.0+0.005)
        IF (i*5.10.LT.MAXI-MINI) i = i + 1
        IF (MOD(i,2).NE.0) i = i + 1
        RESULT = i*divi
        GOTO 40
      ENDIF
C
      IF (INC.LT.0) THEN
C
C       CALCULATE CROSS SECTION SCALES
        IF (ratio.GT.1200.0) THEN
          divi = 10.0
        ELSEIF (ratio.GT.120.0) THEN
          divi = 5.0
        ELSEIF (ratio.GT.12.0) THEN
          divi = 2.0
        ELSE
          divi = 1.0
        ENDIF
C
      ELSEIF (INC.EQ.0) THEN
C
C       CALCULATE STAGE CURVE SCALES
        IF (ratio.GT.1200.0) THEN
          divi = 500.0
        ELSEIF (ratio.GT.1000.0) THEN
          divi = 200.0
        ELSEIF (ratio.GT.450.0) THEN
          divi = 100.0
        ELSEIF (ratio.GT.120.0) THEN
          divi = 50.0
        ELSEIF (ratio.GT.100.0) THEN
          divi = 20.0
        ELSEIF (ratio.GT.45.0) THEN
          divi = 10.0
        ELSEIF (ratio.GT.12.0) THEN
          divi = 5.0
        ELSEIF (ratio.GT.1.0) THEN
          divi = 2.0
        ELSE
          divi = 1.0
        ENDIF
C
      ELSE
C
C       CALCULATE CALCOMP PLOT SCALES
C
        dmy = 1.0
        IF (ratio.GT.1.0) dmy = 10**(IFIX(ALOG10(ratio))+1)
        fact(1) = 0.10*dmy
        fact(2) = 0.15*dmy
        fact(3) = 0.20*dmy
        fact(4) = 0.25*dmy
        fact(5) = 0.30*dmy
        fact(6) = 0.40*dmy
        fact(7) = 0.50*dmy
        fact(8) = 0.60*dmy
        fact(9) = 0.75*dmy
C
   10   DO 20 i = 1, 9
          chk = ratio/fact(i)
          IF (chk.LT.1.0) THEN
            RESULT = fact(i)
            dmy = IFIX(MINI/RESULT)*RESULT
            IF (ABS(dmy-MINI).GT.0.005) dmy = dmy - RESULT
            MINI = dmy
            IF (RESULT*NUMBER+MINI+0.005.GE.MAXI) RETURN
          ENDIF
          fact(i) = fact(i)*10.0
   20   CONTINUE
        GOTO 10
C
      ENDIF
C
      i = IFIX(ratio/divi)
      RESULT = i*divi
      IF ((ratio-RESULT).GT.0.0) RESULT = RESULT + divi
      i = 0
      IF (MINI.LT.0.0) i = 1
C
   30 IF (NUMBER*RESULT.LT.MAXI-IFIX(MINI/RESULT-i)*RESULT) THEN
        RESULT = RESULT + divi
        GOTO 30
      ENDIF
C
   40 IF (RESULT.GT.0.995 .AND. RESULT.LT.1.005) RESULT = one
      RETURN
      END
C
      SUBROUTINE WRDATM(ITYPE)
      INTEGER ITYPE
      INCLUDE 'comdat.cmn'
      INCLUDE 'cgunit.cmn'
      IF (Daref.GT.0.0) THEN
        IF (ITYPE.EQ.2) WRITE (Iprt,9030) Daref, Dtmnam
        IF (ITYPE.EQ.1) WRITE (Iprt,9015) Daref, Dtmnam
      ELSEIF (Daref.LT.0.0) THEN
        IF (ITYPE.EQ.2) WRITE (Iprt,9025) Daref, Dtmnam
        IF (ITYPE.EQ.1) WRITE (Iprt,9010) Daref, Dtmnam
      ELSE
        IF (ITYPE.EQ.2) WRITE (Iprt,9020) Dtmnam
        IF (ITYPE.EQ.1) WRITE (Iprt,9005) Dtmnam
      ENDIF
      RETURN
C
 9005 FORMAT (' DATUM IS ',A20)
 9010 FORMAT (' DATUM IS ',F7.2,' FEET BELOW ',A20)
 9015 FORMAT (' DATUM IS ',F7.2,' FEET ABOVE ',A20)
 9020 FORMAT (11X,'DATUM IS ',A20)
 9025 FORMAT (11X,'DATUM IS ',F7.2,' FEET BELOW ',A20)
 9030 FORMAT (11X,'DATUM IS ',F7.2,' FEET ABOVE ',A20)
      END
C
      FUNCTION XLOC(XNUM,SIZE)
      REAL XNUM, SIZE, XLOC, szhf
      INTEGER ifac
      szhf = -SIZE*0.5
      ifac = 0
      IF (XNUM.NE.0.0) ifac = ALOG10(ABS(XNUM+0.0001))
      XLOC = szhf + szhf*ifac
      IF (XNUM.LT.0.0) XLOC = XLOC + szhf
      END
C
      SUBROUTINE XTRPBN(ZMAX,ZZMIN,IOPT,PRTFLG,IZFLG,IZZFLG,*)
C     EXTRAPOLATE FOR BANKS IF NECESSARY
      INCLUDE 'cgdims.cmn'
      INCLUDE 'comany.cmn'
      INCLUDE 'cgunit.cmn'
      REAL ZMAX, ZZMIN, yp
      INTEGER IOPT, IZFLG, IZZFLG, k
      LOGICAL PRTFLG
      IZFLG = 0
      IZZFLG = 0
      IF (H(1).LT.ZMAX) THEN
        IF (H(2).LT.H(1)) THEN
          yp = (ZMAX-H(1))*(Y(2)-Y(1))/(H(1)-H(2))
          k = Many
          DO 10 k = Many, 1, -1
            IF (IOPT.NE.14 .AND. IOPT.NE.4) THEN
              Y(k+1) = Y(k) + yp
            ELSE
              Y(k+1) = Y(k)
            ENDIF
            H(k+1) = H(k)
   10     CONTINUE
          Many = Many + 1
          H(1) = ZMAX
          IF (IOPT.EQ.14 .OR. IOPT.EQ.4) Y(1) = Y(1) - yp
          IF (PRTFLG) WRITE (Iprt,9015)
          IZFLG = 1 + IZFLG
        ELSE
          ZMAX = H(1)
          IF (IOPT.EQ.7) THEN
            CALL ERRPRT(31)
            RETURN 1
          ENDIF
          IF (PRTFLG) WRITE (Iprt,9005) ZMAX + ZZMIN
          IZZFLG = 1 + IZZFLG
        ENDIF
      ENDIF
      IF (H(Many).LT.ZMAX) THEN
        IF (H(Many).GT.H(Many-1)) THEN
          yp = (ZMAX-H(Many))*(Y(Many)-Y(Many-1))/(H(Many)-H(Many-1))
          Many = Many + 1
          H(Many) = ZMAX
          Y(Many) = Y(Many-1) + yp
          IF (PRTFLG) WRITE (Iprt,9020)
          IZFLG = 2 + IZFLG
        ELSE
          ZMAX = H(Many-1)
          IF (IOPT.EQ.7) THEN
            CALL ERRPRT(31)
            RETURN 1
          ENDIF
          IF (PRTFLG) WRITE (Iprt,9010) ZMAX + ZZMIN
          IZZFLG = 2 + IZZFLG
        ENDIF
      ENDIF
      RETURN
 9005 FORMAT (
     &' EXTRAPOLATION OF THE LEFT BANK CONTOUR TO MAXIMUM STAGE IS NOT P
     &OSSIBLE.',/,' MAXIMUM STAGE IS REDUCED TO',F8.2,' FEET.')
 9010 FORMAT (
     &' EXTRAPOLATION OF THE RIGHT BANK CONTOUR TO MAXIMUM STAGE IS NOT'
     &,/,' POSSIBLE.  MAXIMUM STAGE IS REDUCED TO',F8.2,' FEET.')
 9015 FORMAT (' THE LEFT BANK HAS BEEN EXTRAPOLATED.')
 9020 FORMAT (' THE RIGHT BANK HAS BEEN EXTRAPOLATED.')
      END
