C*** BEGIN FTABLE.INC
C
C     MXTBLE = NUMBER OF STAGE-DEPENDENT COMPUTATIONS
C     MXXSPR = NUMBER OF CROSS SECTIONS PER REACH
C     MAXS   = NUMBER OF CROSS SECTIONS INPUT
C
      INTEGER MXTBLE, MXXSPR, MAXS
      PARAMETER (MXTBLE=150, MXXSPR=20, MAXS=50)
C
C     Define input common blocks
C
      REAL Stage(MXTBLE,MAXS),Dischr(MXTBLE,MAXS),
     $     Area(MXTBLE,MAXS),Width(MXTBLE,MAXS)
      COMMON /XSDAT/ Stage, Dischr, Area, Width
C
      INTEGER Ixsnum(MAXS), Ixsknt(MAXS), Ixsdis(MAXS)
      COMMON /IXSDAT/ Ixsnum, Ixsknt, Ixsdis
C
C     Define output common blocks
C
      REAL Zout(MXTBLE), Qout(MXTBLE), Wtavea(MXTBLE), Wtavew(MXTBLE)  
      COMMON /XSOUT/ Zout, Qout, Wtavea, Wtavew
C
      INTEGER Indx(MXXSPR), Nrows
      COMMON /IXSOUT/ Indx, Nrows
C
C     Define input and output unit numbers
C
      INTEGER IPRT,IRDR,IOTBL,MASTR
      PARAMETER (IPRT=66,IRDR=55,IOTBL=77,MASTR=88)
C
C*** END FTABLE.INC
