      SUBROUTINE MEANOT(IOPT)
C     Last modified October 3, 1995 -- RSR
C
C PUNCH AND PRINT COMPUTED MEANS
      INCLUDE 'cgdims.cmn'
      INCLUDE 'cgunit.cmn'
      INCLUDE 'mngrps.cmn'
      INTEGER i, k, ns, n, is, IOPT, ll
      REAL zzstg, ara, wtp, hyr, wid, q, convey, fslope
      DO 30 k = 1, MXGRPS
        IF (Mnct(k).NE.0) THEN
          WRITE (Iprt,9005) k, Mnct(k)
          n = Mnct(k)
          WRITE (Iprt,9030) (Nxs(i,k),i=1,n)
          CALL WRDATM(2)
          n = Nstor(k)
          ns = n
          IF (n.GT.20) THEN
            DO 10 i = 1, n
              IF (Arsum(i,k).EQ.0.0 .AND. Wdsum(i,k).EQ.0.0) ns = ns-1
   10       CONTINUE
          ENDIF
          IF (IOPT.EQ.17) THEN
            is = Isum(MAX0(2,n)/2,k)
            ll = Lenflw(k)/is
            fslope = Slopes(k)/is
            WRITE (Iprt,9045) k, n + 1, ll, Thalwg(k)
            WRITE (Ipun,9045) k, n + 1, ll, Thalwg(k)
          ELSE
            IF (ns.GT.20) THEN
              WRITE (Iprt,9020) ns, IOPT
              WRITE (Ipun,9020) ns, IOPT
            ENDIF
            WRITE (Ipun,'(I2,4X,''Mean Group'',I3)') n, k
            IF (IOPT.EQ.6) WRITE (Iprt,9025)
            IF (IOPT.EQ.8) WRITE (Iprt,9040)
          ENDIF
          DO 20 i = 1, n
            zzstg = Zstg(i,k)
            ara = Arsum(i,k)
            wtp = Wpsum(i,k)
            hyr = Hrsum(i,k)
            wid = Wdsum(i,k)
            q = Qsum(i,k)
            IF (ara.NE.0.0 .OR. wid.NE.0.0) THEN
              is = Isum(i,k)
              IF (is.GT.1) THEN
                ara = ara/is
                wtp = wtp/is
                hyr = hyr/is
                wid = wid/is
                q = q/is
              ENDIF
              IF (IOPT.EQ.17) THEN
                convey = q/SQRT(fslope)
                WRITE (Iprt,9050) zzstg, q, ara, wid, convey
                WRITE (Ipun,9050) zzstg, q, ara, wid, convey
              ELSEIF (IOPT.EQ.6) THEN
                WRITE (Ipun,9055) zzstg, ara, wid, wtp
                WRITE (Iprt,9015) zzstg, ara, wid, wtp
              ELSE
                WRITE (Ipun,9010) zzstg, wtp, hyr
                WRITE (Iprt,9035) zzstg, wtp, hyr
              ENDIF
            ENDIF
   20     CONTINUE
        ENDIF
   30 CONTINUE
      RETURN
 9005 FORMAT ('1',/,9X,'MEAN CROSS SECTION NUMBER',I3,
     &        '  -  GENERATED BY',I2,' INPUT CROSS SECTIONS :')
 9010 FORMAT (F10.2,2F10.2)
 9015 FORMAT (8X,F10.2,3F16.0)
 9020 FORMAT (' ***WARNING*** Number of values computed (',I2,
     &        ') for option',I2,' exceeds 20.',/,15X,
     &'Therefore if intended for input to the Branch-Network flow model'
     &    ,/,15X,'the file will have to be edited.')
 9025 FORMAT (/,T61,'Wetted',/,T14,'Stage',T30,'Area',T46,'Width',T59,
     &        'Perimeter')
 9030 FORMAT ('+',T83,'NO.''S ',10(I2,', '),9(/,T89,10(I2,', ')))
 9035 FORMAT (8X,F10.2,F16.1,F16.2)
 9040 FORMAT (/,T29,'Wetted',T44,'Hydraulic',/,T14,'Stage',T28,
     &        'Perimeter',T45,'Radius',/)
 9045 FORMAT (/,' Cross Section',I4,'  Values=',I4,'  Distance=',I8,/,
     &        4X,'Stage   Discharge    XS Area  Top Width  Conveyance',
     &        /,F10.2,3(9X,'0.'),10X,'0.')
 9050 FORMAT (F10.2,3F11.1,F12.0)
 9055 FORMAT (F10.2,2F10.1,10X,F10.1)
      END
