      SUBROUTINE PLOTER(KIND,YY,YSCALE,IXX,XSCALE,NN,ZZMIN,YERR,XERR,
     &                  PRTFLG)
      INCLUDE 'cgdims.cmn'
      INCLUDE 'comdat.cmn'
      INCLUDE 'cgunit.cmn'
      INTEGER KIND, NN, IXX(MXCOMP), i, idist, idivd, ifirst, indx, 
     &        ints, irem, iscale, j, k, l, nhead(13)
      REAL YY(MXCOMP), YSCALE, XSCALE, ZZMIN, dmy, alow, aver, chigh, 
     &     clow, high, xu, ymin, xmin, xmax, zinc, ratio, past, xs
      LOGICAL YERR, XERR, PRTFLG
      CHARACTER*2 iee, ioo, iout
      CHARACTER*1 istar, iskip, iplus, ibar, idash, iblank(121), 
     &            ihead(111), mhead
      CHARACTER*6 jout, aout, bout
      REAL a(MXCOMP), c(MXCOMP), x(MXCOMP)
      DATA iee/'EE'/, ihead/2*' ', 'E', 'L', 'E', 'V', 'A', 'T', 'I', 
     &     'O', 'N', ' ', 'A', 'B', 'O', 'V', 'E', ' ', 'T', 'H', 'A', 
     &     'L', 'W', 'E', 'G', ',', ' ', 'I', 'N', ' ', 'F', 'E', 'E', 
     &     'T', 14*' ', 'S', 'T', 'A', 'G', 'E', ',', ' ', 'I', 'N', 
     &     ' ', 'F', 'E', 'E', 'T', 21*' ', 'E', 'L', 'E', 'V', 'A', 
     &     'T', 'I', 'O', 'N', ',', ' ', 'I', 'N', ' ', 'F', 'E', 'E', 
     &     'T', 10*' '/, ioo/'OO'/, aout/' ABOVE'/, bout/' BELOW'/
      DATA istar/'*'/, iskip/' '/, iplus/'+'/, ibar/'|'/, idash/'-'/
C ROUND
      iscale = IFIX(ABS(YSCALE*100.0)+0.5)
      xs = XSCALE*0.5
      DO 10 i = 1, NN
        x(i) = IXX(i) + xs
   10 CONTINUE
      ints = IFIX(XSCALE+0.5)
      xmax = x(NN)
      xmin = x(1)
      IF (KIND.EQ.1) THEN
        indx = 1
        IF (YSCALE.LT.0.0) indx = 75
        ifirst = IFIX(xmin*0.1/ints)*ints*10
        IF (ifirst+120*ints.LT.xmax) ifirst = IFIX(xmin/ints)*ints/10*10
        IF (xmin.LT.0.0) ifirst = ifirst - ints*10
C INTERPOLATE EXTRA POINTS FOR PLOTTING CROSS SECTIONS
        k = 1
        dmy = ifirst
        DO 30 i = 1, 120
          l = 0
          xu = i*XSCALE + ifirst
          IF (x(1).LE.xu) THEN
            DO 20 j = 1, NN
              IF (x(j).GE.dmy) THEN
                IF (x(j).LT.xu) THEN
                  c(k) = x(j)
                  a(k) = YY(j)
                ELSE
                  IF (l.EQ.1 .OR. j.EQ.1) GOTO 20
                  c(k) = dmy + xs
                  a(k) = (YY(j-1)-YY(j))*(c(k)-x(j))/(x(j-1)-x(j))
     &                   + YY(j)
                ENDIF
                k = k + 1
                l = 1
              ENDIF
   20       CONTINUE
          ENDIF
          dmy = xu
   30   CONTINUE
        NN = k - 1
C INITIALIZE
        zinc = YSCALE*5
        IF (zinc.LT.0.0) THEN
          DO 40 k = 1, NN
            a(k) = a(k) + ZZMIN
   40     CONTINUE
          high = -10.0*zinc + ZZMIN - AMOD(ZZMIN,zinc)
          IF (ZZMIN.LT.0. .AND. AMOD(ZZMIN,zinc).NE.0.) high = high + 
     &        zinc
        ELSE
          high = iscale*0.5
        ENDIF
      ELSE
        indx = 38
        ratio = (xmax-xmin)/120.0
        IF (ratio.GT.1200.0) THEN
          ifirst = 5000
        ELSEIF (ratio.GT.450.0) THEN
          ifirst = 1000
        ELSEIF (ratio.GT.120.0) THEN
          ifirst = 500
        ELSEIF (ratio.GT.45.0) THEN
          ifirst = 100
        ELSEIF (ratio.GT.12.0) THEN
          ifirst = 50
        ELSEIF (ratio.GT.1.0) THEN
          ifirst = 20
        ELSE
          ifirst = 10
        ENDIF
        IF (ints.EQ.1000) THEN
          ifirst = 5000
        ELSEIF (ints.EQ.100) THEN
          ifirst = 500
        ELSEIF (ints.EQ.10) THEN
          ifirst = 50
        ENDIF
        j = IFIX(xmin+0.5)
        j = j/ifirst
        IF (xmax.GT.120*ints+j*ifirst+ints*0.5) j = j + 1
        ifirst = j*ifirst
        ymin = YY(1) + 0.00005
        DO 50 i = 1, NN
          a(i) = YY(i)
          c(i) = x(i)
   50   CONTINUE
        high = ymin + FLOAT(50*iscale-iscale/2)*0.01
      ENDIF
      past = high + iscale*0.01
      IF (past.LT.a(1)) YERR = .TRUE.
      idivd = 5
      j = ints*10
      DO 60 i = 1, 13
        nhead(i) = j*(i-1) + ifirst
   60 CONTINUE
C ##### BEGIN LOOP TO PREPARE AND PLOT LINE #####
      DO 130 i = 1, 51
        irem = MOD(idivd,5)
C PREPARE BODY LINE
        IF (idivd.EQ.5 .OR. idivd.EQ.55) THEN
          DO 70 j = 1, 121
            iblank(j) = idash
   70     CONTINUE
          DO 80 j = 1, 121, 10
            iblank(j) = iplus
   80     CONTINUE
        ELSE
          DO 90 j = 1, 121
            iblank(j) = iskip
   90     CONTINUE
          IF (irem.NE.0) THEN
            iblank(1) = ibar
            iblank(121) = ibar
          ELSEIF (KIND.EQ.1) THEN
            iblank(1) = iplus
            iblank(121) = iplus
          ELSE
            DO 100 j = 1, 121, 10
              iblank(j) = iplus
  100       CONTINUE
            IF (PRTFLG) THEN
              DO 110 j = 21, 101, 20
                iblank(j) = iskip
  110         CONTINUE
            ENDIF
          ENDIF
        ENDIF
C PLOT POINTS
        l = 0
        DO 120 k = 1, NN
          IF (a(k).GE.high .AND. a(k).LT.past) THEN
            IF (KIND.NE.1) THEN
              IF (l.EQ.0) THEN
                clow = c(k)
                alow = a(k)
              ELSE
                chigh = c(k)
              ENDIF
              l = l + 1
            ELSE
              idist = IFIX((c(k)-ifirst)/XSCALE) + 1
              IF (idist.GE.1 .AND. idist.LE.121) iblank(idist) = istar
            ENDIF
          ENDIF
  120   CONTINUE
        IF (KIND.NE.1 .AND. l.NE.0) THEN
          IF (l.NE.1) THEN
            aver = high + iscale*0.005
            xu = clow + (aver-alow)*(chigh-clow)
          ELSE
            xu = clow
          ENDIF
          idist = IFIX((xu-nhead(1))/XSCALE) + 1
          IF (idist.GT.0 .AND. idist.LT.122) iblank(idist) = istar
        ENDIF
        past = high
        idivd = idivd + 1
        IF (KIND.EQ.1) THEN
          aver = past
          IF (zinc.GE.0.0) high = (50-i)*iscale*0.01
          IF (zinc.LT.0.0) high = high - iscale*0.01
        ELSE
          high = ymin + FLOAT((50-i)*iscale-iscale/2)*0.01
          aver = ymin + (51-i)*iscale*0.01
        ENDIF
C WRITE OUT HEADERS
        mhead = iskip
C
        IF (i.GT.7 .AND. i.LT.45) THEN
          mhead = ihead(indx)
          indx = indx + 1
        ENDIF
C
        IF (irem.EQ.0) THEN
          WRITE (Iprt,9005) mhead, aver, iblank
        ELSE
          WRITE (Iprt,9010) mhead, iblank
          IF (i.EQ.1 .OR. i.EQ.2) THEN
            IF (KIND.EQ.2) THEN
              WRITE (Iprt,9045) ints
            ELSE
              iout = iee
              IF (ints.EQ.1) iout = ioo
              WRITE (Iprt,9035) ints, iout
              IF (XERR) WRITE (Iprt,9055)
            ENDIF
          ELSEIF (i.EQ.3) THEN
            iout = iee
            IF (IFIX(YSCALE*10000.0+0.5).EQ.10000) iout = ioo
            WRITE (Iprt,9040) ABS(YSCALE), iout
            IF (YERR) WRITE (Iprt,9055)
          ELSEIF (i.EQ.4) THEN
            IF (Daref.EQ.0.0) THEN
              WRITE (Iprt,9060) Dtmnam
            ELSE
              IF (Daref.LT.0.0) THEN
                jout = bout
              ELSE
                jout = aout
              ENDIF
              WRITE (Iprt,9065) ABS(Daref), jout, Dtmnam
            ENDIF
          ELSEIF (i.EQ.5) THEN
            IF (KIND.EQ.1) WRITE (Iprt,9050) ZZMIN
          ENDIF
        ENDIF
C
  130 CONTINUE
C
C ##### END LOOP TO PREPARE AND PLOT LINE #####
      WRITE (Iprt,9015) nhead
      IF (KIND.EQ.1) THEN
        WRITE (Iprt,9020)
      ELSEIF (KIND.EQ.2) THEN
        WRITE (Iprt,9025)
      ELSE
        WRITE (Iprt,9030)
      ENDIF
      RETURN
C
 9005 FORMAT (1X,A1,' ',F7.2,121A1)
 9010 FORMAT (1X,A1,8X,121A1)
 9015 FORMAT (1X,13I10)
 9020 FORMAT (/,34X,
     & 'D I S T A N C E  F R O M  R E F E R E N C E  P O I N T ,  I N  F 
     & E E T')
 9025 FORMAT (/,51X,'A R E A ,  I N  S Q U A R E  F E E T')
 9030 FORMAT (/,57X,'W I D T H ,  I N  F E E T')
 9035 FORMAT ('+',T51,'1 SPACE ON THE X-AXIS = ',I6,' F',A2,'T.')
 9040 FORMAT ('+',T51,'1 LINE  ON THE Y-AXIS = ',F7.2,' F',A2,'T.')
 9045 FORMAT ('+',T51,'1 SPACE ON THE X-AXIS = ',I6,' SQUARE FEET.')
 9050 FORMAT ('+',T54,'THALWEG ELEVATION = ',F7.2,' FEET.')
 9055 FORMAT ('+',T89,'(PARTIAL PLOT)')
 9060 FORMAT ('+',T59,'DATUM IS ',A20)
 9065 FORMAT ('+',T45,'DATUM IS',F8.2,' FEET',A6,1X,A20)
      END
