      SUBROUTINE PROFIL(LYARRY,STAGE,LDIST,LCNT,IPNT,NSTAGE,ND,KTXS,
     &                  IPRT,SNVMAX,DELTAI,IPLTYP,NPLT,LIMIT)
      INCLUDE 'cgdims.cmn'
      REAL yscale, xscale, zz, tmp, round, high, past, ahead, ymin, 
     &     ymax, STAGE(MXCOMP), SNVMAX, DELTAI
      INTEGER NPLT, ileg, ktz, IPLTYP, Nplot(MXCOMP/MXPSTG), 
     &        LDIST(MAXS15), IPNT, NSTAGE, KTXS, IPRT, ND, 
     &        LYARRY(MXCOMP,MAXS15), LIMIT, LCNT, ldmin
      COMMON /SAVEV / Nplot
      CHARACTER*1 ihead(51), arhead(15), whead(15)
      CHARACTER*1 iplus, iskp, ibar, idash, lettrs(MXPSTG), iblank(121)
      INTEGER idivd, irem, iarea(MXPSTG,121), nhead(13), iskip, ifactr, 
     &        i, j, k, im, ii, iylow, isave, init
      LOGICAL first
      DATA arhead/'A', 'R', 'E', 'A', ',', ' ', 'I', 'N', ' ', 'S', 'Q', 
     &     'U', 'A', 'R', 'E'/
      DATA whead/' ', ' ', 'T', 'O', 'P', ' ', 'W', 'I', 'D', 'T', 'H', 
     &     ',', ' ', 'I', 'N'/
      DATA ihead/28*' ', 'F', 'E', 'E', 'T', 19*' '/, init/0/, ldmin/0/
      DATA iplus/'+'/, iskp/' '/, ibar/'|'/, idash/'-'/, lettrs/'A', 
     &     'B', 'C', 'D', 'E'/
      DATA iskip/2147483647/
      DATA nhead/0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12/
      IF (init.EQ.0) THEN
        init = 1
        tmp = LDIST(1)
        ldmin = LDIST(1)
        high = LDIST(KTXS)
        CALL SCALER(xscale,tmp,high,120,0)
        round = xscale*0.5
        DO 10 j = 1, KTXS
          LDIST(j) = IFIX(FLOAT(LDIST(j))+round)
   10   CONTINUE
        nhead(1) = ldmin
        ii = IFIX(10.0*xscale+0.05)
        DO 20 j = 1, 12
          nhead(j+1) = nhead(j) + ii
   20   CONTINUE
        ii = IFIX((SNVMAX-STAGE(IPNT))*DELTAI) + 1
   30   LIMIT = IFIX(FLOAT(ii)/FLOAT(NSTAGE)+0.9)
        irem = MOD(ii,NSTAGE)
        DO 40 i = 1, LIMIT
          Nplot(i) = NSTAGE
   40   CONTINUE
        IF (irem.NE.0) THEN
          IF (irem.LT.(NSTAGE-4)) THEN
            NSTAGE = 5
            WRITE (IPRT,9050)
            GOTO 30
          ELSE
            IF (irem.LT.(NSTAGE-3)) Nplot(LIMIT-1) = Nplot(LIMIT-1) - 1
            IF (irem.LT.(NSTAGE-2)) Nplot(LIMIT) = Nplot(LIMIT) - 1
            IF (irem.LT.(NSTAGE-1)) Nplot(LIMIT-1) = Nplot(LIMIT-1) - 1
            IF (irem.LT.NSTAGE) Nplot(LIMIT) = Nplot(LIMIT) - 1
            WRITE (IPRT,9055)
          ENDIF
        ENDIF
      ENDIF
C
      NPLT = Nplot(ND)
      ymin = LYARRY(LCNT,1)
      DO 50 i = 2, KTXS
        IF (LYARRY(LCNT,i).LT.ymin) ymin = LYARRY(LCNT,i)
   50 CONTINUE
      ii = LCNT + NPLT - 1
      ymax = LYARRY(ii,1)
      DO 60 i = 2, KTXS
        IF (LYARRY(ii,i).GT.ymax) ymax = LYARRY(ii,i)
   60 CONTINUE
      CALL SCALER(yscale,ymax,ymin,50,0)
C
      IF (IPLTYP.EQ.0) THEN
        DO 70 i = 1, 15
          ihead(i+12) = arhead(i)
   70   CONTINUE
      ELSE
        DO 80 i = 1, 15
          ihead(i+12) = whead(i)
   80   CONTINUE
      ENDIF
C
      im = IPNT + NPLT - 1
      k = 0
      DO 100 i = IPNT, im
        k = k + 1
        DO 90 j = 1, KTXS
          LYARRY(k,j) = LYARRY(i,j)
   90   CONTINUE
  100 CONTINUE
C INTERPOLATE EXTRA POINTS
      j = 1
      DO 130 i = 1, 121
        zz = i*xscale + ldmin
        tmp = zz - xscale
        IF (LDIST(j).GE.tmp) THEN
          IF (LDIST(j).LT.zz) THEN
            DO 110 k = 1, NPLT
              iarea(k,i) = LYARRY(k,j)
  110       CONTINUE
            IF (j.GE.KTXS) THEN
              isave = i
              GOTO 140
            ENDIF
          ELSE
            DO 120 k = 1, NPLT
              iarea(k,i) = iskip
  120       CONTINUE
            GOTO 130
          ENDIF
        ENDIF
        j = j + 1
  130 CONTINUE
C INITIALIZE
  140 irem = IFIX(ymin/yscale)
      iylow = IFIX(irem*yscale)
      high = iylow + (50*yscale)
      past = high + yscale
      round = yscale*0.5
C PLOT HEADING
      WRITE (IPRT,9005)
      WRITE (IPRT,9010) xscale
      IF (IPLTYP.EQ.0) THEN
        WRITE (IPRT,9015) yscale
      ELSE
        WRITE (IPRT,9020) yscale
      ENDIF
      CALL WRDATM(2)
      idivd = 5
      ileg = 50 - NPLT
      ktz = NPLT + IPNT - 1
      first = .TRUE.
C BEGIN LOOP TO PREPARE AND PLOT LINE
      DO 220 i = 1, 51
C PREPARE BODY LINE
        irem = MOD(idivd,5)
        IF (idivd.EQ.5 .OR. idivd.EQ.55) THEN
          DO 150 j = 1, 121
            iblank(j) = idash
  150     CONTINUE
          iblank(121) = iplus
          DO 160 j = 1, 111, 10
            iblank(j) = iplus
  160     CONTINUE
        ELSE
          DO 170 j = 1, 121
            iblank(j) = iskp
  170     CONTINUE
          IF (irem.EQ.0) THEN
            iblank(1) = iplus
            iblank(121) = iplus
          ELSE
            iblank(1) = ibar
            iblank(121) = ibar
          ENDIF
        ENDIF
C PLOT POINTS
        ahead = high
        DO 190 k = 1, isave
          DO 180 j = 1, NPLT
C
C   INTERPOLATION STEP
            im = iarea(j,k)
            IF (im.NE.iskip) THEN
              IF (im.LT.IFIX(high-round)) GOTO 180
              IF (im.LT.IFIX(past-round)) iblank(k) = lettrs(j)
            ELSE
C        SKIP INTERPOLATION STEP
              IF (idivd.NE.5 .AND. idivd.NE.55) iblank(k) = iskp
            ENDIF
            GOTO 190
  180     CONTINUE
  190   CONTINUE
        WRITE (IPRT,9030) ihead(i), iblank
        IF (i.EQ.ileg .AND. i.LT.50) THEN
          WRITE (IPRT,9025) lettrs(ktz-IPNT+1), STAGE(ktz)
          ktz = ktz - 1
          ileg = ileg + 1
        ENDIF
        IF (irem.EQ.0) THEN
          IF (first) THEN
            first = .FALSE.
            ifactr = 0
            IF (ahead.GT.9999.99) THEN
              ii = 3
  200         IF ((ahead/10.0**ii).GT.100.0) THEN
                ii = ii + 1
                GOTO 200
              ELSE
                ifactr = ii
                ihead(34) = '*'
                ihead(35) = '1'
                DO 210 ii = 36, 35 + ifactr
                  ihead(ii) = '0'
  210           CONTINUE
              ENDIF
            ENDIF
          ENDIF
          tmp = ahead/10.0**ifactr
          WRITE (IPRT,9035) tmp
        ENDIF
        idivd = idivd + 1
        past = high
        high = iylow + (50-i)*yscale
  220 CONTINUE
C
C PRINT SCALE OF X-AXIS
      WRITE (IPRT,9040) nhead
      WRITE (IPRT,9045)
      RETURN
C
 9005 FORMAT ('1',53X,'S T A G E  P R O F I L E')
 9010 FORMAT ('0',10X,'1 SPACE ON THE X-AXIS =',F7.2,' FEET.')
 9015 FORMAT (11X,'1 LINE  ON THE Y-AXIS =',F7.2,' SQUARE FEET.')
 9020 FORMAT (11X,'1 LINE  ON THE Y-AXIS =',F7.2,' FEET.')
 9025 FORMAT ('+',111X,'Z(',A1,') =',F7.2,' FEET')
 9030 FORMAT (1X,A1,8X,121A1)
 9035 FORMAT ('+',1X,F8.2)
 9040 FORMAT (1X,13I10)
 9045 FORMAT (///,30X,
     &'D I S T A N C E  F R O M  R E F E R E N C E  P O I N T,  I N  F E
     & E T')
 9050 FORMAT (
     &' THE NUMBER OF STAGE VALUES PER PLOT INPUT IS INVALID; IT HAS BEE
     &N CHANGED TO 5.')
 9055 FORMAT (/,
     &' THE NUMBER OF STAGE VALUES PER PLOT HAS BEEN ALTERED TO OBTAIN A
     &N EQUAL DISTRIBUTION.')
      END
