      SUBROUTINE STGPLT(L,STAGE,XAREA,XWIDE)
      INCLUDE 'cgdims.cmn'
      INTEGER L, n1, n2, lenyax, lenxax
      REAL STAGE(MXCOMP), XAREA(MXCPP2), XWIDE(MXCOMP), incr, top, size
      LOGICAL logic
      INCLUDE 'comtdp.cmn'
      INCLUDE 'comax.cmn'
      INCLUDE 'cgunit.cmn'
      size = 0.14
      n1 = L + 1
      n2 = L + 2
      incr = ABS(Zinc)
      Hdrflg = 3
      lenyax = Leny
      lenxax = Lenx
      IF (Zinc.NE.0.0) THEN
        STAGE(n1) = STAGE(1) - AMOD(STAGE(1),incr)
        IF (STAGE(1).LT.STAGE(n1)) STAGE(n1) = STAGE(n1) - incr
        top = STAGE(L) - AMOD(STAGE(L),incr)
        IF (top.LT.STAGE(L)) top = top + incr
        lenyax = (top-STAGE(n1))/incr
        STAGE(n2) = incr
      ELSE
        STAGE(n1) = STAGE(1)
        CALL SCALER(STAGE(n2),STAGE(L),STAGE(n1),lenyax,1)
      ENDIF
      Firval = STAGE(n1)
      Delval = STAGE(n2)
      IF (Iopt.EQ.11 .OR. Iopt.EQ.13) THEN
        IF (Ainc.NE.0.0) THEN
          Ainc = ABS(Ainc)
          XAREA(n1) = XAREA(1) - AMOD(XAREA(1),Ainc)
          XAREA(n2) = Ainc
          IF (XAREA(1).LT.XAREA(n1)) XAREA(n1) = XAREA(n1) - Ainc
          top = XAREA(L) - AMOD(XAREA(L),Ainc)
          IF (top.LT.XAREA(L)) top = top + Ainc
          lenxax = (top-XAREA(n1))/Ainc
        ELSE
          XAREA(n1) = XAREA(1)
          CALL SCALER(XAREA(n2),XAREA(L),XAREA(n1),lenxax,5)
        ENDIF
      ENDIF
      IF (Iopt.EQ.12 .OR. Iopt.EQ.13) THEN
        IF (Winc.NE.0.0) THEN
          Winc = ABS(Winc)
          XWIDE(n1) = XWIDE(1) - AMOD(XWIDE(1),Winc)
          XWIDE(n2) = Winc
          IF (XWIDE(1).LT.XWIDE(n1)) XWIDE(n1) = XWIDE(n1) - Winc
          top = XWIDE(L) - AMOD(XWIDE(L),Winc)
          IF (top.LT.XWIDE(L)) top = top + Winc
          lenxax = (top-XWIDE(n1))/Winc
        ELSE
          XWIDE(n1) = XWIDE(1)
          CALL SCALER(XWIDE(n2),XWIDE(L),XWIDE(n1),lenxax,5)
        ENDIF
      ENDIF
      Ylen = lenyax
      Xlen = lenxax
C
      IF ((.NOT.Pflag) .AND. Parm.EQ.1) CALL PLOTS(Pltunt,1,0)
C
      IF (Iopt.EQ.13) THEN
        CALL FACTOR(.5)
      ELSE
        CALL FACTOR(1.0)
      ENDIF
      CALL PLOT(1.0,1.0,-3)
      CALL NEWPEN(Lblclr)
      logic = .FALSE.
C
C PLOT STAGE CURVES ON CALCOMP PLOTTER (OUTPUT OPTIONS 11, 12, AND 13)
      IF (Iopt.NE.12) THEN
        CALL SYMBOL((Xlen-20.0*size)*0.5,-0.50,size,
     &              'AREA, IN SQUARE FEET',0.0,20)
        CALL DRAXIS(XAREA(n1),XAREA(n2),Zzmin,lenyax,lenxax,0)
        CALL DIGLINE(XAREA,STAGE,L,1,0,2)
        CALL NEWPEN(Lblclr)
        GOTO 20
      ENDIF
   10 CALL SYMBOL((Xlen-14.*size)*.5,-0.50,size,'WIDTH, IN FEET',0.0,14)
      CALL DRAXIS(XWIDE(n1),XWIDE(n2),Zzmin,lenyax,lenxax,0)
      CALL DIGLINE(XWIDE,STAGE,L,1,0,2)
      CALL NEWPEN(Lblclr)
   20 CALL PLTLBL(Nsta,lenyax)
      IF (Iopt.EQ.13) THEN
        IF (logic) THEN
          CALL PLOT(0.0,-Ylen-2.0,-3)
        ELSE
          logic = .TRUE.
          CALL PLOT(0.0,Ylen+2.0,-3)
          GOTO 10
        ENDIF
      ENDIF
      CALL NXTPLT()
      RETURN
      END
