      SUBROUTINE CIOFIL(VERSN)
      CHARACTER*24 VERSN
      CHARACTER*48 pcfile, prname, pcscdn, punnam, pltnam, sbdnam, 
     &             blank, sftnam
      CHARACTER*60 msg
      CHARACTER*80 recrd
      CHARACTER*10 mtrfil
      INCLUDE 'cgunit.cmn'
      LOGICAL okflag, update, outfil, extsms, create, updt, yes
      INTEGER initfl, len, i, retc, iform
      SAVE initfl, extsms, okflag, update, outfil, create, updt, len, 
     &     pcfile, mtrfil, blank
      EXTERNAL OPNFIL, GETCRT, OPNRDR, OPNOTF, GETYES, IOPRMP, CGPCTL,
     &         FILPRE
      DATA initfl/1/, mtrfil/'CGAP.MTR  '/, 
     &     blank/'                                                '/
      IF (initfl.EQ.1) THEN
        initfl = 2
        len = 48
        pcfile = 'cgap.ctl  '
        okflag = .FALSE.
        update = .FALSE.
        outfil = .FALSE.
        extsms = .FALSE.
        create = .FALSE.
        updt = .FALSE.
        WRITE (*,9005) VERSN
        WRITE (*,9010)
C
C---OPEN RESPONSE CAPTURE FILE
        CALL OPNFIL(83,'CGAPLOG.RSP')
        CALL GETCRT
C
C---CHECK STATUS OF CGAP MASTER FILE
        CALL OPNRDR(Mastr,mtrfil,1,retc)
        IF (retc.LT.0) GOTO 50
        IF (retc.EQ.0) THEN
          extsms = .TRUE.
          WRITE (*,9015)
          DO 10 i = 1, 7
            READ (Mastr,'(A80)',END=30) recrd
            WRITE (*,'(A80)') recrd
   10     CONTINUE
          REWIND Mastr
          WRITE (*,9020)
          msg = 'ARE THESE THE REQUIRED FILES FOR THIS EXECUTION'
          CALL GETYES(msg,yes)
          IF (yes) THEN
            okflag = .TRUE.
          ELSE
            update = .TRUE.
          ENDIF
        ENDIF
        IF (.NOT.okflag) WRITE (*,9025)
C
C---IF MASTER FILE NAMES ARE CORRECT USE THEM, OTHERWISE PROMPT USER
   20   IF (okflag .OR. update) THEN
          READ (Mastr,9045) pcfile
          IF (pcfile.EQ.blank) pcfile = 'cgap.ctl'
        ENDIF
        IF (.NOT.okflag) THEN
          msg = 'PROGRAM-CONTROL (INSTREAM) FILE.'
          CALL IOPRMP(msg,pcfile)
        ENDIF
        CALL OPNRDR(Irdr,pcfile,1,retc)
CC       OPEN (Irdr,RECL=100)
        IF (retc.LT.0) GOTO 50
        IF (retc.EQ.1) THEN
          WRITE (*,9030)
          create = .TRUE.
          okflag = .FALSE.
        ENDIF
        IF (.NOT.okflag) THEN
          msg = 
     &      'GENERATE OUTPUT FILE NAMES USING PROGRAM-CONTROL FILE NAME'
          CALL GETYES(msg,yes)
          IF (yes) outfil = .TRUE.
        ENDIF
        CALL FILPRE(pcfile,len)
        IF (create) THEN
          CALL CGPCTL(1)
        ELSE
          msg = 'USE THE INPUT FILE(S) AS THEY ARE'
          CALL GETYES(msg,yes)
          IF (.NOT.yes) updt = .TRUE.
        ENDIF
        IF (updt) CALL CGPCTL(2)
        RETURN
   30   extsms = .FALSE.
        WRITE (*,9035)
        GOTO 20
C
C---SECOND ENTRY POINT, OPEN ALL REQUIRED FILES.
      ENDIF
C
C---ASSIGN THE PRINTED OUTPUT FILE NAME AND OPEN
      IF (extsms) THEN
        READ (Mastr,9045) prname
        READ (Mastr,9045) pcscdn
        READ (Mastr,9045) punnam
        READ (Mastr,9045) pltnam
        READ (Mastr,9045) sftnam
        READ (Mastr,9045) sbdnam
      ELSE
        pltnam = blank
        prname = blank
        pcscdn = blank
        punnam = blank
        sftnam = blank
        sbdnam = blank
      ENDIF
      iform = 0
      CALL OPNOTF(pcfile,len,iform,okflag,outfil,Iprt,'.prt',
     &            'PRINTER OUTPUT FILE.',prname)
C
C---DETERMINE IF OPTION 6, 8, OR 17 IS SPECIFIED AND OPEN FILE
      CALL OPNOTF(pcfile,len,iform,okflag,outfil,Ipun,'.pun',
     &            'OPTION 6, 8, OR 17 OUTPUT FILE, IF REQUIRED.',punnam)
C
C---IF PLOTTER INSTRUCTIONS ARE TO BE OUTPUT, OPEN FILE
      CALL OPNOTF(pcfile,len,iform,okflag,outfil,Pltunt,'.plt',
     &            'DIGITAL-PLOTTER OUTPUT FILE.',pltnam)
C
C---STANDARD FORMAT FILE DESIGNATION
      CALL OPNOTF(pcfile,len,iform,okflag,outfil,Stndrd,'.sft',
     &            'STANDARD FORMAT OUTPUT FILE.',sftnam)
C
C---SUBDIVISION OUTPUT FILE DESIGNATION
      CALL OPNOTF(pcfile,len,iform,okflag,outfil,Sbdunt,'.sbd',
     &            'SUBDIVISION OUTPUT FILE.',sbdnam)
C
C---DETERMINE IF COORDINATE DATA ARE IN SEPARATE FILE AND OPEN
      IF (Idev.EQ.Irdr) THEN
        pcscdn = blank
      ELSE
        IF (pcscdn.EQ.blank) THEN
          pcscdn(1:len) = pcfile(1:len)
          pcscdn(len+1:len+4) = '.pcs'
        ENDIF
        IF (.NOT.okflag) THEN
          msg = 'PCSCD INPUT FILE.'
   40     CALL IOPRMP(msg,pcscdn)
          IF (pcscdn.EQ.pcfile) THEN
            WRITE (*,*) 
     &    '*ERROR* The two input files were specified as the same file.'
            GOTO 40
          ENDIF
        ENDIF
        CALL OPNRDR(Idev,pcscdn,1,retc)
        IF (retc.LT.0) GOTO 50
        IF (retc.EQ.1) THEN
          WRITE (*,9030)
          create = .TRUE.
          okflag = .FALSE.
        ENDIF
      ENDIF
      IF (create) CALL CGPCTL(1)
      IF (updt) CALL CGPCTL(2)
C
      REWIND Mastr
      WRITE (Mastr,9040) 'Program-control input    :', pcfile
      WRITE (Mastr,9040) 'Printer output           :', prname
      WRITE (Mastr,9040) 'PCSCD input              :', pcscdn
      WRITE (Mastr,9040) 'Option 6, 8, or 17 output:', punnam
      WRITE (Mastr,9040) 'Digital-plotting output  :', pltnam
      WRITE (Mastr,9040) 'Opt 9 output-Standard fmt:', sftnam
      WRITE (Mastr,9040) 'Opt 16 output-Subdivision:', sbdnam
      ENDFILE Mastr
      CLOSE (Mastr)
      WRITE (*,*) 'File initialization completed!'
      RETURN
   50 STOP '**Error** in ciofil, check access rights or file in use.'
 9005 FORMAT (////,18X,'Welcome to CGAP - ',A,/,3X,
     &'Documentation:  USGS Water-Resources Investigations Report 85-433
     &5',/,12X,'"A Computer Program for Analyzing Channel Geometry"',//,
     &' You may enter "Q" to any prompt to discontinue initiation of the
     & program.',/,
     &' If the displayed or default value following a prompt is acceptab
     &le, a',/,
     &' carriage return is sufficient response, otherwise a new value mu
     &st be',/,
     &' entered.  The default response to a "yes/no" query is yes.',/)
 9010 FORMAT (1X,
     &'Input to CGAP can be split between two files, the program-control
     & and the',/,
     &' PCSCD file, and consists of eight record types divided into thre
     &e groups:',/,
     &' 1) IDENTITY, DATA FORMAT, PROCESSING CONTROL, and PARAMETER ALTE
     &RATIONS;',/,
     & ' 2) PARAMETER, COMMENT, and SUBDIVISION (PCS); and 3) COORDINATE 
     & DATA (CD).',/,
     &' The program-control file must always contain group 1 records.  I
     &t may also',/,
     &' contain group 2 records or contain all input records.  The PCSCD
     & file may',/,
     &' be empty, contain group 2 and 3 records, or contain only group 3
     & records.',/,
     &' Input flags (IDEV and KDEV) designate the file location of the i
     &nput records.')
 9015 FORMAT (
     &  ' These are the current file names in your CGAP master file:',/)
 9020 FORMAT (
     &' Note, all named output files will be deleted and(or) overwritten
     & by CGAP.',/)
 9025 FORMAT (/
     &   ' Prompts will be issued for the names of all required files.')
 9030 FORMAT (/' Prompts will be issued to create it.')
 9035 FORMAT (/,1X,
     &      '*ERROR* End of file for master file, will create new file')
 9040 FORMAT (1X,A26,1X,A48)
 9045 FORMAT (28X,A48)
      END
C
      SUBROUTINE CGPCTL(IFLG)
C
C   Last modified December 11, 1992
C   modified April 15, 1992 -- RSR
C
C   IFLG = 1, CREATE NEW INSTREAM AND CD FILE
C   IFLG = 2, UPDATE EXISTING INSTREAM FILE
C
C  THIS IS AN INTERACTIVE PROCEDURE FOR CGAP THAT WILL SET UP BOTH
C  FILES NEEDED--THE DATA AND THE INFORMATION--FOR THE BEGINNER AND
C  FOR THE EXPERIENCED USER.
C
C  VARIABLE DECLARATIONS
C
      INCLUDE 'cgdims.cmn'
      INCLUDE 'cgunit.cmn'
      INCLUDE 'comtdp.cmn'
      INCLUDE 'cgcctl.cmn'
      INCLUDE 'comany.cmn'
      INCLUDE 'comsbd.cmn'
      REAL zmin, daref, fslope, mangsn
      INTEGER e431, kkdev, iskip, leny, npar, altpch, nxpos, nset, retc, 
     &        i, j, k, iidev, IFLG, lupcs, lucd, irdrsv
      CHARACTER*80 iden(MAXCOM)
      CHARACTER*100 recrd
      CHARACTER*1 ans(40)
      CHARACTER*64 msg(3), msg1
      CHARACTER*40 answ
      EQUIVALENCE (ans(1),answ), (msg(1),msg1)
      CHARACTER xsrang*5, stanam*22, ibcd*22, dtmnam*20, form*60, 
     &          dfmt*26
      LOGICAL init, update, le431, append, mnmsg, zmsg, incmsg, found, 
     &        yes
      SAVE init, update, append
      DATA init/.TRUE./, update/.FALSE./, append/.FALSE./
      DATA ibcd/'    POTOMAC RIVER     '/, iidev/1/, 
     &     stanam/'     XS 1 - XS 2      '/, xsrang/' 1-2 '/, irdrsv/5/, 
     &     form/'(14X,F8.1,3X,F8.2,5X,I2)'/, e431/0/, kkdev/0/, 
     &     dfmt/'(T15,F8.1,T26,F8.2,T39,I2)'/, le431/.FALSE./, iskip/0/, 
     &     answ/'                                        '/
C
      IF (init) THEN
        init = .FALSE.
        CALL OPNSCR(Scrch3)
        IF (IFLG.NE.1) THEN
          update = .TRUE.
          READ (Irdr,9195,END=30,ERR=30) ibcd, stanam, xsrang
          READ (Irdr,9200,END=30,ERR=30) form, e431, iidev, kkdev
C
C   IF CD ARE INSTREAM MAJOR PROBLEMS
C   IF PCS ARE IN PCSCD FILE NEED TO PROMPT FOR CD ALONG WITH PARAMETER
C
   10     READ (Irdr,9215,END=20) recrd
          WRITE (Scrch3,9215) recrd
          GOTO 10
   20     REWIND Scrch3
          GOTO 40
   30     WRITE (*,9090)
          ibcd = ' THREE MILE SLOUGH'
          stanam = '   RIO VISTA'
          xsrang = ' 1-5'
          form = '(T15,F8.1,T26,F8.2,T39,I2)'
          e431 = 0
          iidev = 0
          kkdev = 0
        ENDIF
   40   CALL OPNSCR(Scrch1)
        CALL OPNSCR(Scrch2)
        irdrsv = Irdr
        Irdr = Scrch1
        IF (update) THEN
          msg(1) = 'Update ALL input (default)'
          msg(2) = 'Begin update at PARAMETER records'
          msg(3) = 'Begin update at PROCESSING-CONTROL records'
          CALL GET012(msg,iskip,retc)
          IF (retc.NE.0) GOTO 300
        ENDIF
        IF (iskip.LT.1) THEN
          CALL GETIDN(ibcd,stanam,xsrang)
C
C  THE NEXT QUESTIONS ARE FOR THE DATA FORMAT RECORD
C
          WRITE (*,9005)
          IF (e431.EQ.0) THEN
            WRITE (*,*) 
     &'If coordinate data are in step-backwater program format, set E431
     & to 1.'
            CALL GETIVL('E431',0,1,e431)
          ENDIF
          le431 = e431.EQ.1
          IF (.NOT.le431) THEN
            WRITE (*,9010)
   50       CALL GETCVL('FORM',form)
            IF (form(:1).NE.'(') THEN
              WRITE (*,9100)
              GOTO 50
            ENDIF
            WRITE (*,*) 
     &  'If coordinate data are in the PCSCD input file, set IDEV to 1.'
            CALL GETIVL('IDEV',0,1,iidev)
            IF (iidev.EQ.0) THEN
              kkdev = 0
            ELSE
              WRITE (*,9095)
              CALL GETIVL('KDEV',0,1,kkdev)
            ENDIF
          ELSE
            WRITE (*,9105)
            e431 = 0
            form = dfmt
            iidev = 1
            kkdev = 1
            msg1 = 
     & 'ARE THE E431 DATA IN A FILE OTHER THAN THE PROGRAM-CONTROL FILE'
            CALL GETYES(msg1,yes)
            IF (.NOT.yes) THEN
              iidev = 0
              kkdev = 0
            ELSE
              WRITE (*,9110)
            ENDIF
          ENDIF
        ENDIF
C
        WRITE (Irdr,9195) ibcd, stanam, xsrang
        WRITE (Irdr,9200) form, e431, iidev, kkdev
        REWIND Irdr
        RETURN
      ENDIF
C
C  SET VARIABLES TO DEFAULT VALUES
C
      lucd = Idev
      lupcs = Kdev
      IF (Idev.EQ.Irdr) lucd = Scrch3
      IF (Kdev.EQ.Irdr) lupcs = Scrch3
      Nsta = 0
      Ncom = 0
      zmin = 0.0
      Zmax = 0.0
      Deltaz = 1.0
      Deg = 0.0
      Ndsd = 0
      Mn1 = 0
      Mn2 = 0
      Dacorr = 0.0
      Zinc = 0.0
      Dinc = 0.0
      Nsubs = 0
      Ainc = 0.0
      Winc = 0.0
      fslope = 0.0
      mangsn = 0.0
      DO 60 i = 1, MAXCOM
        iden(i) = '  '
   60 CONTINUE
      CALL MOVE0(Subd,MXSUBS)
      CALL MOVE0(Subman,MXSUB1)
      Iopt = 5
      leny = 6
      Thedeg = 75.0
      npar = 0
      altpch = 0
      daref = 0.0
      nxpos = 0
      nset = MAXS15
      Nstage = MXPSTG
      dtmnam = 'NGVD OF 1929'
C
C  FOR THE BEGINNER, THESE ARE THE QUESTIONS ASKED OF THE USER SO THAT
C  THEY ARE ABLE TO GET STARTED. THIS IS TO KEEP CONFUSION TO A MINIMUM
C
C  THE NEXT QUESTIONS GET INFORMATION FOR THE PARAMETER RECORDS
C
      IF (iskip.EQ.2) GOTO 170
      IF (iskip.NE.1) THEN
        WRITE (*,9015)
        CALL GETCRT
      ENDIF
   70 Nsta = Nsta + 1
      IF (update .AND. .NOT.append) THEN
        READ (lupcs,9215,END=80) recrd
C        IF COLS 1&2 ARE BLANK, FOUND FIRST PROCESSING CONTROL RECORD.
        IF (recrd(1:2).NE.'  ') THEN
          BACKSPACE lupcs
          CALL READXS(Nsta,zmin,Zinc,Dinc,Ainc,Winc,fslope,mangsn,iden,
     &                le431,form,lupcs,lucd,found)
          IF (found) GOTO 90
        ENDIF
   80   msg1 = 
     &       'ERROR OR EOF FOUND LOOKING FOR PARAMETER RECORD, CONTINUE'
        CALL GETYES(msg1,yes)
        IF (.NOT.yes) GOTO 300
        append = .TRUE.
      ENDIF
   90 k = 23
      ans(37) = 'T'
C
  100 k = k + 1
      IF (k.EQ.38) THEN
        msg1 = 'ENTER VARIABLE NUMBER, A, T, D, F, OR ?:'
        CALL GETCHR(msg1,recrd)
        READ (recrd,9190) ans
        CALL UPCASE(answ(:38))
        k = 1
        zmsg = .TRUE.
        mnmsg = .TRUE.
        incmsg = .TRUE.
      ENDIF
      IF (k.EQ.1 .AND. ans(1).EQ.' ') ans(1) = 'F'
      IF (ans(k).NE.' ' .AND. ans(k).NE.',') THEN
        IF (ans(k).EQ.'?') THEN
          WRITE (*,9015)
          GOTO 100
        ENDIF
        IF (ans(k).EQ.'A') THEN
          answ = '1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,t'
          k = 1
        ENDIF
        IF (ans(k).EQ.'F') THEN
          WRITE (Scrch1,9205) Nsta, Ncom, zmin, Zmax, Deltaz, Deg, Ndsd, 
     &                        Mn1, Mn2, Dacorr, Zinc, Dinc, Nsubs, Ainc, 
     &                        Winc, fslope, mangsn
          IF (Ncom.NE.0) WRITE (Scrch1,9210) (iden(i),i=1,Ncom)
          IF (Nsubs.NE.0) WRITE (Scrch1,9220) (Subd(i),i=1,MXSUBS), 
     &                           (Subman(i),i=1,MXSUB1)
          IF (update .AND. .NOT.append) THEN
            WRITE (*,9115)
            msg1 = 'ARE THE CD FOR THIS CROSS SECTION OK'
            CALL GETYES(msg1,yes)
            i = 0
C    NOTE, IF UPDATING INPUT FILES, AND ALL DATA ARE INSTREAM, COULD PUT
C    RECORDS OUT OF ORDER IF ADDING A NEW STATION, THE FOLLOWING READ/WRITE
C    STATEMENTS CAN PUT THE PROCESSING CONTROL RECORDS BEFORE THE CD RECORDS
C    IF THE RESPONSE TO THE ABOVE QUESTION IS YES OR CARRIAGE RETURN EVEN
C    THOUGH THE CD RECORDS DO NOT EXIST YET.
            IF (yes) THEN
              DO 110 i = 1, Many
                WRITE (Scrch2,form) Y(i), H(i), i
  110         CONTINUE
              WRITE (Scrch2,form)
              GOTO 120
            ENDIF
          ENDIF
          CALL GETCD(form,update,Scrch2)
C
  120     CALL ANTHRP(Ncom,Nsubs,update,*170)
          GOTO 70
C
        ELSEIF (ans(k).EQ.'Q') THEN
          GOTO 300
        ELSEIF (ans(k).EQ.'D') THEN
          msg1 = 
     &    'ARE YOU SURE YOU WANT TO DELETE THE PARAMETER AND CD RECORDS'
          CALL GETYES(msg1,yes)
          IF (yes) THEN
            Nsta = Nsta - 1
            CALL ANTHRP(Ncom,Nsubs,update,*170)
            GOTO 70
          ENDIF
        ELSEIF (ans(k).EQ.'T') THEN
          WRITE (*,9080) Nsta, Dacorr, Ncom, Zinc, zmin, Dinc, Zmax, 
     &                   Nsubs, Deltaz, Ainc, Deg, Winc, Ndsd, fslope, 
     &                   Mn1, mangsn, Mn2
          IF (Ncom.NE.0) WRITE (*,9120) (i,iden(i),i=1,Ncom)
          IF (Nsubs.NE.0) THEN
            DO 130 i = 1, Nsubs + 1
              IF (Subman(i).LE.0.0) Subman(i) = mangsn
  130       CONTINUE
            WRITE (*,9125) (Subd(i),i=1,Nsubs)
            WRITE (*,9135) (Subman(i),i=1,Nsubs+1)
          ENDIF
        ELSE
          IF (ans(k).LT.'0' .OR. ans(k).GT.'9') THEN
            WRITE (*,9175) ans(k)
            GOTO 100
          ENDIF
          READ (ans(k),9185) i
          IF (k.LT.37 .AND. ans(k+1).GE.'0' .AND. ans(k+1).LE.'9') THEN
            k = k + 1
            READ (ans(k),9185) j
            i = i*10 + j
          ENDIF
          IF (i.LT.1 .OR. i.GT.17) THEN
            WRITE (*,'(A,I5,A)') '*ERROR* -- Invalid number entered', i, 
     &                           ' values are 1-17.'
            GOTO 100
          ENDIF
          WRITE (*,*)
          IF (i.EQ.1) THEN
            WRITE (*,*) 
     &'A two-digit, non-zero number is used to uniquely identify the cro
     &ss section.'
            CALL GETIVL('NSTA',1,99,Nsta)
          ELSEIF (i.EQ.2) THEN
            WRITE (*,9130) MAXCOM
            CALL GETIVL('NCOM',0,MAXCOM,Ncom)
            DO 140 j = 1, Ncom
              WRITE (*,9075)
              CALL GETCVL('IDEN',iden(j))
  140       CONTINUE
          ELSEIF (i.EQ.3) THEN
            IF (zmsg) WRITE (*,9025)
            zmsg = .FALSE.
            CALL GETRVL('ZMIN',2,-99999.,999999.,zmin)
          ELSEIF (i.EQ.4) THEN
            IF (zmsg) WRITE (*,9025)
            zmsg = .FALSE.
            CALL GETRVL('ZMAX',2,-99999.,999999.,Zmax)
          ELSEIF (i.EQ.5) THEN
            IF (zmsg) WRITE (*,9025)
            zmsg = .FALSE.
            CALL GETRVL('DELTAZ',2,-99999.,999999.,Deltaz)
          ELSEIF (i.EQ.6) THEN
            WRITE (*,9030)
            CALL GETRVL('DEG',0,0.0,90.0,Deg)
          ELSEIF (i.EQ.7) THEN
            WRITE (*,9035)
            CALL GETIVL('NDSD',-99999,999999,Ndsd)
          ELSEIF (i.EQ.8) THEN
            IF (mnmsg) WRITE (*,9040)
            mnmsg = .FALSE.
            CALL GETIVL('MN1',0,MXGRPS,Mn1)
          ELSEIF (i.EQ.9) THEN
            IF (mnmsg) WRITE (*,9040)
            mnmsg = .FALSE.
            CALL GETIVL('MN2',0,MXGRPS,Mn2)
          ELSEIF (i.EQ.10) THEN
            WRITE (*,9045)
            CALL GETRVL('DACORR',2,-999999.,9999999.,Dacorr)
          ELSEIF (i.EQ.11) THEN
            IF (incmsg) WRITE (*,9050)
            incmsg = .FALSE.
            CALL GETRVL('ZINC',1,-9999.,99999.,Zinc)
          ELSEIF (i.EQ.12) THEN
            IF (incmsg) WRITE (*,9050)
            incmsg = .FALSE.
            CALL GETRVL('DINC',1,-9999.,99999.,Dinc)
          ELSEIF (i.EQ.13) THEN
            j = Nsubs
            WRITE (*,9065) MXSUBS
            CALL GETIVL('NSUBS',0,MXSUBS,Nsubs)
            IF (j.NE.0 .AND. Nsubs.NE.0) THEN
              WRITE (*,9125) (Subd(i),i=1,j)
              WRITE (*,9135) (Subman(i),i=1,j+1)
            ENDIF
            DO 150 j = 1, Nsubs
              CALL GETRVL('SUBD(j)',2,-999999.,9999999.,Subd(j))
  150       CONTINUE
            DO 160 j = 1, Nsubs + 1
              CALL GETRVL('SUBMAN(j)',4,0.0,99999.,Subman(j))
  160       CONTINUE
          ELSEIF (i.EQ.14) THEN
            IF (incmsg) WRITE (*,9050)
            incmsg = .FALSE.
            CALL GETRVL('AINC',1,-9999.,99999.,Ainc)
          ELSEIF (i.EQ.15) THEN
            IF (incmsg) WRITE (*,9050)
            incmsg = .FALSE.
            CALL GETRVL('WINC',1,-9999.,99999.,Winc)
          ELSEIF (i.EQ.16) THEN
            WRITE (*,9055)
            CALL GETRVL('FSLOPE',4,-1.0,1.0,fslope)
          ELSEIF (i.EQ.17) THEN
            WRITE (*,9060)
            CALL GETRVL('MANGSN',3,0.0,99999.,mangsn)
          ENDIF
        ENDIF
      ENDIF
      GOTO 100
C
C  THE NEXT QUESTIONS GET INFORMATION FOR THE PROCESSING CONTROL
C
  170 IF (update) CALL RDREST(lupcs,lucd,le431,form)
      IF (iskip.LT.1) THEN
        WRITE (*,9020)
        CALL GETCRT
      ENDIF
  180 k = 23
      ans(24) = 'T'
      IF (update) THEN
        READ (Scrch3,9225,END=200) Iopt, leny, Thedeg, npar, altpch, 
     &                             daref, nxpos, nset, Nstage, dtmnam
        DO 190 i = 1, npar
          READ (Scrch3,9215) recrd
          IF (i.LT.11) iden(i) = recrd(:80)
  190   CONTINUE
        IF (i.GT.10) npar = 0
      ENDIF
C
  200 k = k + 1
      IF (k.EQ.25) THEN
        msg1 = 'ENTER VARIABLE NUMBER, A, T, D, F, L, OR ?:'
        CALL GETCHR(msg1,recrd)
        READ (recrd,9190) ans
        CALL UPCASE(answ(:25))
        k = 1
      ENDIF
      IF (k.EQ.1 .AND. ans(1).EQ.' ') ans(1) = 'F'
      IF (ans(k).EQ.'?') THEN
        WRITE (*,9020)
      ELSEIF (ans(k).NE.' ' .AND. ans(k).NE.',') THEN
        IF (ans(k).EQ.'A') THEN
          answ = '1,2,3,4,5,6,7,8,9,10,t'
          k = 1
        ENDIF
        IF (ans(k).EQ.'F' .OR. ans(k).EQ.'D') THEN
          IF (ans(k).NE.'D') THEN
            WRITE (Scrch1,9225) Iopt, leny, Thedeg, npar, altpch, daref, 
     &                          nxpos, nset, Nstage, dtmnam
            DO 210 i = 1, npar
              WRITE (Scrch1,9210) iden(i)
  210       CONTINUE
          ENDIF
          msg1 = 
     &  'DO YOU WANT TO UPDATE OR ADD ANOTHER PROCESSING-CONTROL RECORD'
          CALL GETYES(msg1,yes)
          IF (yes) GOTO 180
C
C  WRITE TO FILE
C
C     THE READER AND SCRATCH FILES ARE REWOUND. THE CONTENTS
C     OF THE SCRATCH FILES ARE WRITTEN TO THE READER FILE
C     AND THE READER FILE IS TRUNCATED TO AVOID ANY EXTRANEOUS
C     DATA AT THE END OF THE FILE.
C     DATA ARE WRITTEN IN 80 CHARACTER FIELDS.  THE PRIME COMPUTERS
C     AUTOMATICALLY TRUNCATE TRAILING BLANKS IN FILE RECORDS.  ON
C     MICRO'S AND PC'S THIS COULD CAUSE DATA FILES TO 80 COLUMN WIDE
C     FILES, THEREFORE TAKING UP EXCESSIVE SPACE.
C
C     THE FOLLOWING IS COMMENTED OUT SO THAT ALL PROCESSING CONTROL RECORDS
C     THAT REMAIN IN THE FILE AFTER UPDATING ARE NOT KEPT.
C296  IF (UPDATE) THEN
C297     READ(SCRCH3,9196,END=299) recrd
C        WRITE(SCRCH1,9196) recrd
C        GO TO 297
C     ENDIF
C299  REWIND IRDR
          Irdr = irdrsv
          IF (Idev.EQ.Scrch1) Idev = Irdr
          IF (Kdev.EQ.Scrch1) Kdev = Irdr
          REWIND Irdr
          IF (Idev.NE.Irdr) REWIND Idev
          REWIND Scrch1
          READ (Scrch1,9195) ibcd, stanam, xsrang
          READ (Scrch1,9200) form, e431, iidev, kkdev
          WRITE (Irdr,9195) ibcd, stanam, xsrang
          WRITE (Irdr,9200) form, e431, iidev, kkdev
          REWIND Scrch2
  220     READ (Scrch1,'(I2,2X,I1,T64,I1,T1,A100)',END=280) Nsta, Ncom, 
     &          Nsubs, recrd
          IF (Nsta.NE.0) THEN
            CALL WRTREC(Kdev,recrd)
            IF (Nsubs.NE.0) Ncom = Ncom + 1
            DO 230 i = 1, Ncom
              READ (Scrch1,9210) recrd
              CALL WRTREC(Kdev,recrd)
  230       CONTINUE
  240       READ (Scrch2,9215) recrd
            CALL WRTREC(Idev,recrd)
            IF (recrd.EQ.'        ') GOTO 220
            GOTO 240
          ENDIF
C
C     WRITE PROCESSING CONTROL TO IRDR
C
  250     CALL WRTREC(Irdr,recrd)
          READ (Scrch1,9215,END=290) recrd
          GOTO 250
        ENDIF
        IF (ans(k).EQ.'Q') GOTO 300
        IF (ans(k).EQ.'T') THEN
          WRITE (*,9085) Iopt, daref, leny, nxpos, Thedeg, nset, npar, 
     &                   Nstage, altpch, dtmnam
        ELSEIF (ans(k).EQ.'L') THEN
          WRITE (*,9070)
        ELSE
          WRITE (*,*)
          IF (ans(k).LT.'0' .OR. ans(k).GT.'9') THEN
            WRITE (*,9175) ans(k)
            GOTO 200
          ENDIF
          READ (ans(k),9185) i
          IF (k.LT.24 .AND. ans(k+1).GE.'0' .AND. ans(k+1).LE.'9') THEN
            k = k + 1
            READ (ans(k),9185) j
            i = i*10 + j
          ENDIF
          IF (i.LT.1 .OR. i.GT.10) THEN
            WRITE (*,*) '*ERROR* -- Enter a number between 1 and 10'
          ELSEIF (i.EQ.1) THEN
            WRITE (*,*) 'CGAP has 16 output options (5 is the default)'
            CALL GETIVL('IOPT',0,16,Iopt)
            IF (Iopt.EQ.0) Iopt = 5
          ELSEIF (i.EQ.2) THEN
            WRITE (*,9140)
  260       CALL GETIVL('LENY',0,12,leny)
            IF (leny.EQ.0) leny = 6
            IF ((leny.NE.4) .AND. (leny.NE.6) .AND. (leny.NE.8) .AND. 
     &          (leny.NE.0) .AND. (leny.NE.10) .AND. (leny.NE.12)) THEN
              WRITE (*,9180) leny
              GOTO 260
            ENDIF
          ELSEIF (i.EQ.3) THEN
            WRITE (*,9145)
            CALL GETRVL('THEDEG',0,0.0,360.0,Thedeg)
            IF (Thedeg.EQ.0.0) Thedeg = 75.0
          ELSEIF (i.EQ.4) THEN
            WRITE (*,*) 'Number of parameter alteration records input'
            CALL GETIVL('NPAR',0,10,npar)
            IF (npar.NE.0) THEN
              msg1 = 'THE FULL PARAMETER ALTERATION RECORD'
              DO 270 i = 1, npar
                CALL GETCVL(msg1,iden(i))
  270         CONTINUE
            ENDIF
          ELSEIF (i.EQ.5) THEN
            WRITE (*,9155)
            CALL GETIVL('ALTPCH',0,1,altpch)
          ELSEIF (i.EQ.6) THEN
            WRITE (*,9150)
            CALL GETRVL('DAREF',2,-999999.,9999999.,daref)
          ELSEIF (i.EQ.7) THEN
            WRITE (*,9160)
            CALL GETIVL('NXPOS',0,99,nxpos)
            IF (Iopt.EQ.15 .AND. nxpos.EQ.0) nxpos = 1
          ELSEIF (i.EQ.8) THEN
            WRITE (*,9165)
            CALL GETIVL('NSET',0,99,nset)
            IF (Iopt.EQ.15 .AND. (nset.EQ.0 .OR. nset.GT.MAXS15))
     &          nset = MAXS15
          ELSEIF (i.EQ.9) THEN
            WRITE (*,9170)
            CALL GETIVL('NSTAGE',0,MAXS7,Nstage)
            IF (Iopt.EQ.7 .AND. Nstage.EQ.0) nset = MAXS7
            IF (Iopt.EQ.15 .AND. (Nstage.EQ.0 .OR. Nstage.GT.MXPSTG))
     &          Nstage = MXPSTG
          ELSEIF (i.EQ.10) THEN
            WRITE (*,*) 
     &'The name of the common datum reference is used in to label output
     &.'
            CALL GETCVL('DTMNAM',dtmnam)
          ENDIF
        ENDIF
      ENDIF
      GOTO 200
  280 WRITE (*,*) 'NO PROCESSING-CONTROL RECORDS FOUND'
      GOTO 170
  290 IF (Idev.NE.Irdr) THEN
        ENDFILE Idev
        REWIND Idev
      ENDIF
      ENDFILE Irdr
      REWIND Irdr
      READ (Irdr,9210)
      READ (Irdr,9210)
      CLOSE (Scrch1,STATUS='DELETE')
      CLOSE (Scrch2,STATUS='DELETE')
      IF (update) CLOSE (Scrch3,STATUS='DELETE')
      RETURN
  300 STOP 'by user request'
C
 9005 FORMAT (/,
     &' Prompts are issued to update the variables of the DATA FORMAT re
     &cord.',/,
     &' These variables define the input format of the coordinate data a
     &nd the',/,' file location of the different input record types.',/)
 9010 FORMAT (/
     &' The input format of the COORDINATE-DATA records may be defined b
     &y specifying',/,
     &' a valid FORTRAN format (including outside parentheses, in a 60-c
     &haracter',/,
     &' field).  The default format is (14X,F8.1,3X,F8.2,5X,I2).  If spe
     &cified, you',/,
     &' must allow for reading two Floating-point values and one Integer
     & value per',/,
     &' record.  Note, the above format specifies that cross-channel dis
     &tance values',/,
     &' are coded in record postitions 15-22 with one implied decimal pl
     &ace, elevation',/,
     &' values are coded in 26-33 with two implied decimal places, and I
     &nteger',/,' sequence numbers are coded in 39 and 40.')
 9015 FORMAT (/,' Prompts are issued to update the variables of the PARA
     &METER record.',/,' These variables define computational parameters
     & that control the processing',/,' of the associated coordinate dat
     &a for each cross section.  A table is',/,
     &' displayed showing the current values assigned to these variables
     &.  The',/,
     &' following options are available to modify values for this record
     &.  You may',/,
     &' enter up to ten of these options per response, separated by a bl
     &ank or',/,' comma, i.e. 3,4 5, 8, 7,T.',//,4X,'Code',t35,
     &'Function',/,6X,'#  --  To change the value of a variable, enter i
     &ts NUMBER (as',/,13X,'shown in the table) and the new VALUE when r
     &equested.',/,6X,
     &'A  --  To change the values of ALL PARAMETER record variables.',
     &/,6X,'T  --  To redisplay the parameter values TABLE',/,6X,
     &'F  --  When FINISHED (saves changes and begins CD entry, default)
     &',/,6X,'D  --  To DELETE this PARAMETER record and corresponding',
     &/,13X,'COORDINATE-DATA records from the input files.',/,6X,
     &'?  --  To redisplay this message.')
 9020 FORMAT (/,
     &' Prompts are issued to update PROCESSING-CONTROL (PC) record vari
     &ables.',/,' These variables define computational parameters that c
     &ontrol the processing',/,' of all cross-section data.  If PC recor
     &ds exist in the input file from a',/,
     &' previous execution, they are only retained if interactively sele
     &cted',/,' (original file is truncated after updates).',//,1X,
     &'A table is displayed showing the current values assigned to these
     & variables.',/,' The following options are available to modify val
     &ues for this record.  You',/,' may enter up to ten options per res
     &ponse, separated by a blank or comma,',/,' i.e. 3,4 5, 8, 7,T,L.',
     &//,4X,'Code',T35,'Function',/,6X,
     &'#  --  To change the value of a variable, enter its NUMBER (as',
     &/,13X,'shown in the table) and the new VALUE when requested.',/,
     &6X,'A  --  To change the values of ALL PC record variables.',/,6X,
     &'T  --  To redisplay the parameter values TABLE',/,6X,
     &'F  --  When FINISHED (saves changes and begins execution, default
     &)',/ ,6X,'D  --  To DELETE this PROCESSING-CONTROL record from the
     & input file.',/,6X,'L  --  To LIST descriptions of the available o
     &utput options.',/,6X,'?  --  To redisplay this message.')
 9025 FORMAT (
     &' The minimum stage for computation (ZMIN), maximum stage for comp
     &utation',/,
     &' (ZMAX), and the computational stage increment (DELTAZ) determine
     & the',/,
     &' range and number of elevations at which cross-sectional properti
     &es are',/,
     &' computed.  There must exist at least two data points defined bel
     &ow ZMIN',/,
     &' and only one channel at ZMIN.  CGAP linearly extrapolates channe
     &l banks to',/,
     &' ZMAX if its value exceeds the channel-bank elevations.  ZMIN, ZM
     &AX, and',/,
     &' DELTAZ must be specified such that properties are not computed f
     &or more than',/,
     &' 80 elevations for option 16, 40 for options 6 & 8 with mean grou
     &ps (BRANCH',/,
     &' expects 20 for option 6), and 250 for other options.  ZMIN and D
     &ELTAZ',/,' have no affect for options 4, 7, and 14.')
 9030 FORMAT (
     &' CGAP assumes that cross-sections were measured along a line perp
     &endicular',/,
     &' to the flow direction at the channel thalweg.  If this was not d
     &one,',/,
     &' set DEG to the absolute value of the difference between the cros
     &s section',/,
     &' line and the line perpendicular to the flow direction.  CGAP adj
     &usts the',/,' coordinate data to account for this variation.')
 9035 FORMAT (
     &' For options 5, 7, 15, & 16 the distance between successive cross
     & sections',/,
     &' (XS) must be known.  This can be specified as segment lengths be
     &tween cross',/,
     &' sections (NDSD=0 for first XS) or as a distance from a reference
     & point',/,
     &' along the channel thalweg (NDSD other than 0 for first XS).')
 9040 FORMAT (
     &' MN1 and MN2 are used to specify the output order and averaging o
     &f cross-',/,
     &' sectional data into geometry tables for options 6 and 8.  If MN1
     & and MN2',/,
     &' equal zero for all cross sections, a geometry table is output (i
     &n input order)',/,
     &' for each cross section.  Otherwise, tables are output only for t
     &hose cross',/,
     &' sections with non-zero MN1 and/or MN2 values.  Each cross sectio
     &n may be',/,
     &' included in at most two geometry tables by setting MN1 and MN2 t
     &o different',/,
     &' values.  The order of output for geometry tables is from the low
     &est MN1 or MN2',/,
     &' value to the highest (range 1-99).  Cross sections having the sa
     &me value for',/,
     &' either MN1 or MN2, will be averaged and output as a single geome
     &try table.')
 9045 FORMAT (
     &' Elevations for all cross sections must be referenced to a common
     & datum.',/,
     &' The value of DACORR is added to the elevations of this cross sec
     &tion.')
 9050 FORMAT (' Plots are automatically scaled to maximize use of the gr
     &aphics image.',/,' User-defined elevation (ZINC), distance (DINC),
     & area (AINC), and width',/,' (WINC) scaling increments can be spec
     &ified for each cross section.  These',/,' can be used, for example
     & to set uniform plot scaling for all cross section',/,
     &' plots.  For line printer plots, ZINC is the elevation represente
     &d by 5 lines',/,' and the other variables are represented by 10 sp
     &aces.  If specified too',/,
     &' small, partial plots can occur.  For digital plots, the values r
     &epresent',/,' one increment (one inch at full scale) on the coores
     &ponding axis.  The axes',/,
     &' lengths on digital plots are adjusted to accommodate producing t
     &he plot',/,
     &' at the specified scaling increments.  For cross-section plots, a
     & negative',/,
     &' value of ZINC signals CGAP to reference elevations to the common
     & datum',/,
     &' (depth plots), otherwise the channel thalweg is used as the plot
     & reference',/,' (elevation above thalweg plots).')
 9055 FORMAT (
     &' The friction (channel-bed) slope is used in the Manning''s equat
     &ion to',/,' compute the section discharge.')
 9060 FORMAT (' This channel roughness value is used in the Manning''s e
     &quation to',/,' compute the section discharge.')
 9065 FORMAT (
     &' Option 16 generates tables of area and width as functions of sta
     &ge for',/,' subdivisions of a cross section.  Up to',i2,
     &' distances in a cross section',/,
     &' can be designated as subdivision points (6 points yields 7 subun
     &its).',/,
     &' Enter the number of subdivision points, NSUBS, then each distanc
     &e, SUBD(j)',/,' and roughness value, SUBMAN(j).')
 9070 FORMAT (' Option                 Description',/,2X,
     &        '1  Area as a function of stage plot on line printer (LP)'
     &        ,/,2X,'2  Width as a function of stage plot on LP',/,2X,
     &        '3  Combination of optin 1 and 2 on LP',/,2X,
     &        '4  Channel cross-section plot on LP',/,2X,
     &        '5  Listing of channel properties as functions of stage',
     &   /,2X,'6  Sequential file of area/width as functions of stage',
     &   /,2X,'7  Cross-sections plotted in isometric projection on DP',
     &/,2X,'8  Wetted perimeter/hydraulic radius as functions of stage',
     & /,2X,'9  PCS and CD records stored in standard format to a file',
     &  /,1X,'10  Listing of PCS and CD records',/,1X,
     &       '11  Same as 1 on digital plotter (DP)',/,1X,
     &       '12  Same as 2 on DP',/,1X,'13  Same as 3 on DP',/,1X,
     &       '14  Same as 4 on DP',/,1X,
     &       '15  Area at a fixed stage as a function of distance on LP'
     & ,/,1X,'16  Listing of area/width as functions of stage for subdiv
     &isions')
 9075 FORMAT (/,'Enter up to 80 characters of descriptive information.')
 9080 FORMAT (/,2X,'#',5X,'Definition',6X,'Variable  Value    #',6X,
     &        'Definition',5X,'Variable  Value',/,1X,79('-'),/,
     &        '  1 Cross-section number   NSTA',I8,' |',
     &        ' 10 Datum correction     DACORR',F8.2,/,
     &        '  2 Number of comments     NCOM',I8,' |',
     &        ' 11 Stage plot increment   ZINC',F8.1,/,
     &        '  3 Minimum stage          ZMIN',F8.2,' |',
     &        ' 12 Distance plot incr.    DINC',F8.1,/,
     &        '  4 Maximum stage          ZMAX',F8.2,' |',
     &        ' 13 # of subdivision pts. NSUBS',I8,/,
     &        '  5 Computational incr.  DELTAZ',F8.2,' |',
     &        ' 14 Area plot increment    AINC',F8.1,/,
     &        '  6 XS degree rotation      DEG',F8.0,' |',
     &        ' 15 Width plot increment   WINC',F8.1,/,
     &        '  7 Subreach distance      NDSD',I8,' |',
     &        ' 16 Friction slope       FSLOPE',F8.4,/,
     &        '  8 First mean group        MN1',I8,' |',
     &        ' 17 Manning`s N          MANGSN',F8.3,/,
     &        '  9 Second mean group       MN2',I8)
 9085 FORMAT (/,2X,'#',6X,'Definition',5X,'Variable  Value   #',6X,
     &        'Definition',6X,'Variable  Value',/,1X,79('-'),/,
     &        '  1 Output option            IOPT',I5,' |',
     &        '  6 Global datum correct.   DAREF',F7.2,/,
     &        '  2 Plot axis length         LENY',I5,' |',
     &        '  7 1st xs number incl.     NXPOS',I7,/,
     &        '  3 Viewing angle, opt 7   THEDEG',F5.0,' |',
     &        '  8 # consectuive xs incl.   NSET',I7,/,
     &        '  4 # Parameter Alterations  NPAR',I5,' |',
     &        '  9 # units per plot       NSTAGE',I7,/,
     &        '  5 output flag, opt 6,8   ALTPCH',I5,' |',
     &        ' 10 Datum name    "',A20,'"')
 9090 FORMAT (' *ERROR* End of or bad file, you will be prompted to crea
     &te the',/,' instream file, overwriting anything in the named instr
     &eam file.')
 9095 FORMAT (/,
     &' If PARAMETER records are in the PCSCD input file, set KDEV to 1.
     &')
 9100 FORMAT (/,
     &' *ERROR* Invalid Format entered, check for specification of outsi
     &de parentheses.')
 9105 FORMAT (/,
     &' Step-backwater formatted data will be formatted and stored in CG
     &AP default',/,
     &' format upon completion of the update process, overwriting origin
     &al input files.')
 9110 FORMAT (/,
     &' Enter its file name when prompted later for the second input (PC
     &SCD) file.',/,
     &' This file will be reformatted in CGAP default format.')
 9115 FORMAT (/,
     &' You may re-enter the COORDINATE-DATA records associated with thi
     &s PARAMETER',/,
     &' record (note, you must enter all records or leave them as they a
     &re.')
 9120 FORMAT (/,' COMMENT RECORDS:',/,5(I2,')',2X,A80,/))
 9125 FORMAT (' SUBDIVISION POINTS:',6F9.2)
 9130 FORMAT (' Up to',i2,
     &    ' comment records may be input following a PARAMETER record.')
 9135 FORMAT (' ROUGHNESS VALUES:',7F9.4)
 9140 FORMAT (
     &' The length of the axes for digital plots can be specified.  LENY
     & is the',/,
     &' length in inches of the y axis (the x axis is set to 25% larger)
     &.  If scaling',/,
     &' increments are specified on PARAMETER records (ZINC,DINC,AINC,WI
     &NC), then',/,' these values can override the value of LENY.')
 9145 FORMAT (
     &' For option 7, cross sections are aligned along the channel thalw
     &eg in the',/,
     &' plot.  The angle between the x-axis and thalweg line can be vari
     &ed.  For',/,
     &' a vertical view of the cross sections, set THEDEG=90.0.')
 9150 FORMAT (
     &' Elevations for all cross sections must be referenced to a common
     & datum.',/,
     &' The value of DAREF is added to the elevations of all cross secti
     &ons.')
 9155 FORMAT (
     &' If you want option 6 or 8 output in BRANCH-input format, set ALT
     &PCH=0.',/,
     &' If you want option 16 output in GENFTBL format, set ALTPCH=1.')
 9160 FORMAT (
     &' For options 7 and 15, set NXPOS equal to the cross section numbe
     &r (NSTA)',/,
     &' of the first cross section to be included in the output.')
 9165 FORMAT (
     &' For options 7 and 15, set NSET equal to the number of consecutiv
     &e cross',/,' sections to be included in the output.')
 9170 FORMAT (
     &' For option 7, set NSTAGE equal to the number of cross sections s
     &hown in',/,
     &' one "stack" (default is 5, note that the last cross section in a
     & stack is',/,
     &' repeated as the first cross section in the next stack).  For opt
     &ion 15,',/,
     &' set NSTAGE equal to the number of stages shown on each line-prin
     &ter page.')
 9175 FORMAT ('*ERROR* -- Invalid response -- ',A)
 9180 FORMAT ('*ERROR* -- Invalid response --',I5,/,
     &        ' POSSIBLE VALUES FOR LENY ARE: 4, 6, 8, 10, OR 12')
 9185 FORMAT (I1)
 9190 FORMAT (40A1)
 9195 FORMAT (T7,A22,1X,A22,1X,A5)
 9200 FORMAT (A60,T76,I1,2I2)
 9205 FORMAT (I2,2X,I1,3(F7.2),F3.0,I6,1X,2I2,F8.2,2(1X,F6.1),1X,I1,
     &        2(F6.1),4X,F6.4,F6.3)
 9210 FORMAT (A80)
 9215 FORMAT (A100)
 9220 FORMAT (2X,6F8.2,7F8.4)
 9225 FORMAT (2X,2I2,F3.0,3X,I3,2X,I1,F8.2,3I2,A20)
      END
C
      SUBROUTINE ANTHRP(NCOM,NSUBS,UPDATE,*)
C
C  Last modified Febuary 4, 1992 -- RSR
C
C  VARIABLE DECLARATIONS
C
      INTEGER NCOM, NSUBS
      LOGICAL UPDATE, yes
      CHARACTER*62 msg
      IF (UPDATE) THEN
        WRITE (*,9005)
        msg = 
     &  'DO YOU WANT TO UPDATE OR ADD THE NEXT PARAMETER AND CD RECORDS'
      ELSE
        msg = 
     &    'DO YOU WANT TO ENTER ANOTHER SET OF PARAMETER AND CD RECORDS'
      ENDIF
      CALL GETYES(msg,yes)
      IF (.NOT.yes) RETURN 1
      WRITE (*,9010)
      NCOM = 0
      NSUBS = 0
      RETURN
C
 9005 FORMAT (/,
     &' Note, to retain the remaining PCSCD records, answer no to the ne
     &xt prompt.')
 9010 FORMAT (/,1X,
     &'Prompts will be issued to update the variables of the parameter r
     &ecord.')
      END
C
      SUBROUTINE GETIDN(IBCD,STANAM,XSRANG)
C
C  Last modified Febuary 3, 1992 -- RSR
C
C  VARIABLE DECLARATIONS
C
      CHARACTER XSRANG*5, STANAM*22, IBCD*22, msg*6
C
C  IDENTITY RECORD
C
      WRITE (*,9005)
C
      WRITE (*,*) 
     &'Define the name of the water body, centered in a 22-character fie
     &ld.'
      msg = 'IBCD '
      CALL GETCVL(msg,IBCD)
      WRITE (*,*) 
     &'Define other water-body identification, centered in a 22-characte
     &r field.'
      msg = 'STANAM'
      CALL GETCVL(msg,STANAM)
      WRITE (*,*) 
     &'Define the range of cross-section numbers, centered in a 5-charac
     &ter field.'
      msg = 'XSRANG'
      CALL GETCVL(msg,XSRANG)
      RETURN
 9005 FORMAT (/,1X,
     &'Prompts will be issued to define the variables of the IDENTITY re
     &cord.',/,
     &' These variables are used for annotation purposes on the title pa
     &ge for',/,
     &' each option.  The water body name is also shown on digital plots
     &.',/)
      END
C
      SUBROUTINE GETCD(FORM,UPDATE,SCRCH2)
C
C  Last modified Febuary 4, 1992 -- RSR
C
      CHARACTER*60 FORM, ms(2), strng
      CHARACTER*1 strng1
      CHARACTER*12 fmt
      INTEGER ntot, idot, iblk, i, j, k, iblky, im, SCRCH2, retc
      LOGICAL UPDATE
      REAL a, b
C
      INCLUDE 'cgdims.cmn'
      INCLUDE 'comany.cmn'
      EQUIVALENCE (strng,strng1)
C
C     GET COORDINATE DATA RECORDS
C
   10 ntot = 0
      a = 0.0
      b = 0.0
      im = 0
   20 WRITE (*,9015)
      ms(1) = 
     &      'ENTER DISTANCE/ELEVATION COORDINATE-DATA PAIR, F, D, OR ?.'
   30 IF (UPDATE) THEN
        im = im + 1
        IF (im.LE.Many) THEN
          a = Y(im)
          b = H(im)
        ELSE
          a = 0.0
          b = 0.0
        ENDIF
      ENDIF
      WRITE (ms(2),9020) a, b
      CALL GETSTR(2,ms,strng,retc)
      IF (retc.NE.0) STOP
C the following could produce a problem if a number is entered in "'s
      IF (strng1.EQ.'"') strng1 = strng(2:2)
      IF (strng1.EQ.'?') GOTO 20
      IF (strng1.EQ.'F' .OR. strng1.EQ.'f') THEN
        IF (ntot.EQ.0) THEN
          WRITE (*,9010)
          GOTO 10
        ENDIF
        WRITE (SCRCH2,FORM)
      ELSEIF (strng1.EQ.'d' .OR. strng1.EQ.'D') THEN
        IF (ntot.GT.0) THEN
          BACKSPACE SCRCH2
          READ (SCRCH2,FORM) a, b
          BACKSPACE SCRCH2
          WRITE (*,9005) a, b
          ntot = ntot - 1
        ELSE
          WRITE (*,9010)
          GOTO 10
        ENDIF
        GOTO 30
      ELSE
        iblk = 0
        IF (strng(:4).NE.'    ') THEN
          idot = 0
          DO 60 i = 1, 60
            IF (strng(i:i).EQ.'.') idot = i
            IF (strng(i:i).EQ.' ' .OR. strng(i:i).EQ.',') THEN
              iblk = i - 1
              IF (idot.EQ.0) idot = iblk
              WRITE (fmt,'(A2,I2,A1,I1,A1)',ERR=80) '(F', iblk, '.', 
     &               iblk - idot, ')'
              READ (strng,fmt,ERR=80) a
              iblk = iblk + 1
              DO 50 j = iblk, 80
                IF (strng(j:j).NE.' ' .AND. strng(j:j).NE.',') THEN
                  iblk = j
                  iblky = 0
                  idot = 0
                  DO 40 k = iblk, 80
                    IF (strng(k:k).EQ.'.') idot = k
                    IF (strng(k:k).EQ.' ' .OR. strng(k:k).EQ.',') THEN
                      iblky = k - 1
                      iblk = iblk - 1
                      IF (idot.EQ.0) idot = iblky
                      WRITE (fmt,'(A1,I2,A3,I2,A1,I1,A1)') '(', iblk, 
     &                       'X,F', iblky - iblk, '.', iblky - idot, ')'
                      READ (strng,fmt,ERR=80) b
                      GOTO 70
                    ENDIF
   40             CONTINUE
                  GOTO 80
                ENDIF
   50         CONTINUE
              WRITE (*,*) 
     &'*ERROR* only one value entered, must enter both values to prompt.
     &'
              im = im - 1
              GOTO 80
            ENDIF
   60     CONTINUE
          GOTO 80
        ENDIF
   70   ntot = ntot + 1
        WRITE (SCRCH2,FORM) a, b, ntot
        Y(im) = a
        H(im) = b
        IF (ntot.EQ.MAXPTS) THEN
          WRITE (*,*) 
     &    '*WARNING* Number of points is at limit for a cross section ('
     &    , MAXPTS, ')'
          WRITE (SCRCH2,FORM)
          RETURN
        ENDIF
C        NEED TO CHECK IF ntot = MAXPTS, SHOULD MAKE USER GO TO NEXT
        GOTO 30
   80   WRITE (*,*) '*ERROR* -- Invalid response -- ', strng(1:12)
        im = im - 1
        GOTO 30
      ENDIF
      Many = ntot
      RETURN
C
 9005 FORMAT (/,' The CD pair (',f8.2,',',f8.2,') has been deleted.')
 9010 FORMAT (' *ERROR* -- No coordinate data entered')
 9015 FORMAT (/,
     &' Enter coordinate data as pairs with the distance value first and
     & one pair',/,
     &' per response.  Enter "F" to the prompt when finished entering da
     &ta for',/,
     &' the cross section.  Enter "D" to delete the last entered CD pair
     &.  Enter a',/,
     &' carriage return to accept the values displayed in the prompt.')
 9020 FORMAT ('CURRENT VALUES:',f9.2,',',f8.2)
      END
C
      SUBROUTINE RDREST(LUPCS,LUCD,LE431,FORM)
C
C     Last modified December 8, 1992
C     MODIFIED DECEMBER 19, 1991 -- RSR
C
      INTEGER i, LUPCS, LUCD
      INCLUDE 'cgunit.cmn'
      INCLUDE 'cgdims.cmn'
      INCLUDE 'comany.cmn'
      INCLUDE 'cgcctl.cmn'
      INCLUDE 'comsbd.cmn'
      INTEGER nsta
      REAL zmin, zinc, dinc, ainc, winc, fslope, mangsn
      LOGICAL LE431, found
      CHARACTER*60 FORM
      CHARACTER*80 ident(MAXCOM)
C
   10 READ (LUPCS,'(I2)',ERR=20,END=30) nsta
      IF (nsta.NE.0) THEN
        BACKSPACE LUPCS
        CALL READXS(nsta,zmin,zinc,dinc,ainc,winc,fslope,mangsn,ident,
     &              LE431,FORM,LUPCS,LUCD,found)
C
C     WRITE RECORDS FOR THIS CROSS SECTION TO FILE
C
        IF (.NOT.found) THEN
          WRITE (*,*) 'END OF FILE ENCOUNTERED READING COORDINATE DATA'
          STOP
        ELSE
          WRITE (Scrch1,9005) nsta, Ncom, zmin, Zmax, Deltaz, Deg, Ndsd, 
     &                        Mn1, Mn2, Dacorr, zinc, dinc, Nsubs, ainc, 
     &                        winc, fslope, mangsn
          IF (Ncom.NE.0) WRITE (Scrch1,'(A80)') (ident(i),i=1,Ncom)
          IF (Nsubs.NE.0) WRITE (Scrch1,'(2X,6F8.2,7F8.4)')
     &                           (Subd(i),i=1,MXSUBS), 
     &                           (Subman(i),i=1,MXSUB1)
          WRITE (Scrch2,FORM) (Y(i),H(i),i,i=1,Many)
          WRITE (Scrch2,FORM)
C
          GOTO 10
        ENDIF
      ENDIF
   20 BACKSPACE LUPCS
   30 RETURN
 9005 FORMAT (I2,2X,I1,3(F7.2),F3.0,I6,1X,2I2,F8.2,2(1X,F6.1),1X,I1,
     &        2(F6.1),4X,F6.4,F6.3)
      END
C
      SUBROUTINE WRTREC(IUNT,REC)
C     Last modified December 8, 1992
      INTEGER IUNT, i
      CHARACTER*100 REC
      DO 10 i = 100, 1, -1
        IF (REC(i:i).NE.' ') THEN
          WRITE (IUNT,'(A)') REC(1:i)
          GOTO 20
        ENDIF
   10 CONTINUE
      WRITE (IUNT,*)
   20 RETURN
      END
