      SUBROUTINE LSTOPT(DEFFMT,IERR,*,*)
C     Last modified December 8, 1992
      INTEGER IERR, nsta, ncom, ndsd, mn1, mn2, nsubs, many, ktpage, i, 
     &        nn, num(5), ktline, j
      CHARACTER*26 DEFFMT
C
C LIST WITH HEADINGS EVERY PARAMETER RECORD AND DATA SET
C (OUTPUT OPTION 10)
C
      CHARACTER*8 blank8, sub1
      INCLUDE 'cgdims.cmn'
      INCLUDE 'cgunit.cmn'
      INCLUDE 'prmalt.cmn'
      INCLUDE 'comsbd.cmn'
      CHARACTER*80 ident(MAXCOM)
      REAL yd(5), zd(5), zmin, zmax, deltaz, deg, dacorr, zinc, dinc, 
     &     ainc, winc, fslope, mangsn
      DATA blank8/'        '/
      ktpage = 0
   10 READ (Idev,9055,END=80,ERR=90) nsta, ncom, zmin, zmax, deltaz, 
     &                               deg, ndsd, mn1, mn2, dacorr, zinc, 
     &                               dinc, nsubs, ainc, winc, many, 
     &                               fslope, mangsn
      DO 20 i = 1, Npar
        IF (nsta.EQ.Nxsec(i)) THEN
          zmin = Tmin(i)
          zmax = Tmax(i)
          deltaz = Tinc(i)
          deg = Ddeg(i)
          ndsd = Kdsd(i)
          mn1 = Kmn1(i)
          mn2 = Kmn2(i)
          dacorr = Datm(i)
          zinc = Tzinc(i)
          dinc = Tdinc(i)
          ainc = Tainc(i)
          winc = Twinc(i)
          fslope = Tslope(i)
          mangsn = Tmansn(i)
          GOTO 30
        ENDIF
   20 CONTINUE
   30 ktline = 11 + ncom + (many+4)/5
      IF (nsubs.GT.0) ktline = ktline + 5
      IF (ktpage+ktline.GT.58) THEN
        ktpage = 0
        WRITE (Iprt,9065)
      ENDIF
      WRITE (Iprt,9005)
      WRITE (Iprt,9010) nsta, ncom, zmin, zmax, deltaz, deg, ndsd, mn1, 
     &                  mn2, dacorr, zinc, dinc, nsubs, ainc, winc
      IF (fslope.NE.0.0 .OR. mangsn.NE.0.0) WRITE (Iprt,9015) fslope, 
     &    mangsn
      DO 40 i = 1, ncom
        READ (Idev,9060,END=90) ident(i)
   40 CONTINUE
      IF (nsubs.NE.0) READ (Idev,9050,END=90,ERR=90)
     &                      (Subd(i),i=1,MXSUBS), (Subman(i),i=1,MXSUB1)
      IF (nsubs.NE.0) THEN
        WRITE (Iprt,9020)
        WRITE (Iprt,9025) (Subd(i),i=1,MXSUBS), (Subman(i),i=1,MXSUB1)
      ENDIF
      DO 50 i = 1, ncom
        WRITE (Iprt,'(1X,A80)') ident(i)
   50 CONTINUE
      CALL WRDATM(1)
      READ (Idev,'(2X,A8)',END=70) sub1
      IF (sub1.NE.blank8) THEN
        IERR = 10
        RETURN 1
      ENDIF
      BACKSPACE Idev
      WRITE (Iprt,9030)
      nn = 5
      DO 60 i = 1, many, 5
        IF (i+4.GT.many) nn = many - i + 1
        READ (Idev,DEFFMT,END=70,ERR=90) (yd(j),zd(j),num(j),j=1,nn)
        WRITE (Iprt,9035) (yd(j),zd(j),num(j),j=1,nn)
   60 CONTINUE
      READ (Idev,DEFFMT,END=70,ERR=90)
      WRITE (Iprt,9040)
      ktpage = ktpage + ktline
      GOTO 10
   70 IERR = 4
      RETURN 1
   80 WRITE (Iprt,9045)
      RETURN
   90 RETURN 2
 9005 FORMAT (
     &' CROSS    COMMENT  MINIMUM  MAXIMUM  STAGE      X-S ANGLE  DISTAN
     &CE   FIRST  SECOND  ELEVATION  DEPTH  DIST   NUMBER   AREA   WIDTH
     &',/,
     &' SECTION  RECORDS  STAGE    STAGE    INCREMENT  VARIANCE   OR LEN
     &GTH  GROUP  GROUP   TO DATUM   SCALE  SCALE  OF SUBS  SCALE  SCALE
     &',/,1X,4(7('='),2X),3(9('='),2X),5('='),2X,6('='),2X,9('='),2X,
     &2(5('='),2X),7('='),2X,2(5('='),2X))
 9010 FORMAT (3X,I2,7X,I2,3X,3F9.2,4X,F7.1,4X,I7,5X,I2,6X,I2,4X,F8.2,
     &        F8.1,F7.1,4X,I2,3X,2F7.1,/)
 9015 FORMAT (' FRICTION  MANNING''S',/,3X,'SLOPE',7X,'N',/,1X,8('='),
     &        2X,9('='),/,F9.4,F11.3,/)
 9020 FORMAT (T28,'SUBDIVISION POINTS',43X,'ROUGHNESS VALUES',/,T28,
     &        18('='),43X,16('='))
 9025 FORMAT (T12,6F8.2,8X,7F8.4,/)
 9030 FORMAT (/,4('DISTANCE ELEVATION NO.',5X),'DISTANCE ELEVATION NO.')
 9035 FORMAT ((1X,4(F8.1,1X,F8.1,2X,I3,5X),F8.1,1X,F8.1,2X,I3))
 9040 FORMAT (1X,2(/,1X))
 9045 FORMAT (' THE DATA SET LISTING AS DEFINED BY OUTPUT OPTION 10 IS C
     &OMPLETE.')
 9050 FORMAT (2X,6F8.2,7F8.4)
 9055 FORMAT (I2,2X,I1,3(F7.2),F3.0,I6,1X,2I2,F8.2,2(1X,F6.1),1X,I1,
     &        2(F6.1),I4,F6.4,F6.3)
 9060 FORMAT (A80)
 9065 FORMAT ('1')
      END
